searchData={"items":[{"type":"module","title":"ExTwilio","doc":"ExTwilio is a relatively full-featured API client for the Twilio API.\n\nIf you're a user, take a look at the various Resource modules, such as\n`ExTwilio.Account` and `ExTwilio.Call`.\n\nIf you want to learn more about how ExTwilio works internally, take a gander\nat:\n\n- `ExTwilio.Api`\n- `ExTwilio.Resource`\n- `ExTwilio.Parser`","ref":"ExTwilio.html"},{"type":"module","title":"ExTwilio.Account","doc":"Represents an Account or Subaccount resource.\n\n- [Account docs](https://www.twilio.com/docs/iam/api/account)\n- [Subaccount docs](https://www.twilio.com/docs/api/rest/subaccounts)","ref":"ExTwilio.Account.html"},{"type":"module","title":"Examples - ExTwilio.Account","doc":"An `ExTwilio.Account` can represent either an Account or a SubAccount. To see\nall accounts and subaccounts that your auth_token has access to, run:\n\n    ExTwilio.Account.all\n\nIf you want to find a SubAccount, use `find/1`.\n\n    ExTwilio.Account.find(\"sid\")\n\nIf you want to see items associated with a SubAccount, you can do so by\npassing in an `account:` option in all other ExTwilio resources. For example:\n\n    ExTwilio.Call.stream(account: \"subaccount_sid\")","ref":"ExTwilio.Account.html#module-examples"},{"type":"function","title":"ExTwilio.Account.all/1","doc":"","ref":"ExTwilio.Account.html#all/1"},{"type":"function","title":"ExTwilio.Account.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Account.html#children/0"},{"type":"function","title":"ExTwilio.Account.close/1","doc":"Permanently close an Account by updating its status to \"closed\". This cannot\nbe undone, so use it carefully!\n\n- [Twilio Docs](https://www.twilio.com/docs/api/rest/subaccounts#closing-subaccounts)","ref":"ExTwilio.Account.html#close/1"},{"type":"function","title":"Examples - ExTwilio.Account.close/1","doc":"{:ok, account} = ExTwilio.Account.find(\" \")\n    ExTwilio.Account.close(account)","ref":"ExTwilio.Account.html#close/1-examples"},{"type":"function","title":"ExTwilio.Account.create/2","doc":"","ref":"ExTwilio.Account.html#create/2"},{"type":"function","title":"ExTwilio.Account.do_new/2","doc":"","ref":"ExTwilio.Account.html#do_new/2"},{"type":"function","title":"ExTwilio.Account.find/2","doc":"","ref":"ExTwilio.Account.html#find/2"},{"type":"function","title":"ExTwilio.Account.new/0","doc":"","ref":"ExTwilio.Account.html#new/0"},{"type":"function","title":"ExTwilio.Account.new/1","doc":"","ref":"ExTwilio.Account.html#new/1"},{"type":"function","title":"ExTwilio.Account.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Account.html#parents/0"},{"type":"function","title":"ExTwilio.Account.reactivate/1","doc":"Reactivate a suspended Account by updating its status to \"active\".\n\n- [Twilio Docs](https://www.twilio.com/docs/api/rest/subaccounts#suspending-subaccounts)","ref":"ExTwilio.Account.html#reactivate/1"},{"type":"function","title":"Examples - ExTwilio.Account.reactivate/1","doc":"{:ok, account} = ExTwilio.Account.find(\" \")\n    ExTwilio.Account.reactivate(account)","ref":"ExTwilio.Account.html#reactivate/1-examples"},{"type":"function","title":"ExTwilio.Account.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Account.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Account.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Account.html#resource_name/0"},{"type":"function","title":"ExTwilio.Account.stream/1","doc":"","ref":"ExTwilio.Account.html#stream/1"},{"type":"function","title":"ExTwilio.Account.suspend/1","doc":"Suspend an Account by updating its status to \"suspended\".\n\n- [Twilio Docs](https://www.twilio.com/docs/api/rest/subaccounts#suspending-subaccounts)","ref":"ExTwilio.Account.html#suspend/1"},{"type":"function","title":"Examples - ExTwilio.Account.suspend/1","doc":"{:ok, account} = ExTwilio.Account.find(\" \")\n    ExTwilio.Account.suspend(account)","ref":"ExTwilio.Account.html#suspend/1-examples"},{"type":"function","title":"ExTwilio.Account.update/3","doc":"","ref":"ExTwilio.Account.html#update/3"},{"type":"module","title":"ExTwilio.Address","doc":"Represents an Address resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/usage/api/address)","ref":"ExTwilio.Address.html"},{"type":"function","title":"ExTwilio.Address.all/1","doc":"","ref":"ExTwilio.Address.html#all/1"},{"type":"function","title":"ExTwilio.Address.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Address.html#children/0"},{"type":"function","title":"ExTwilio.Address.create/2","doc":"","ref":"ExTwilio.Address.html#create/2"},{"type":"function","title":"ExTwilio.Address.do_new/2","doc":"","ref":"ExTwilio.Address.html#do_new/2"},{"type":"function","title":"ExTwilio.Address.find/2","doc":"","ref":"ExTwilio.Address.html#find/2"},{"type":"function","title":"ExTwilio.Address.new/0","doc":"","ref":"ExTwilio.Address.html#new/0"},{"type":"function","title":"ExTwilio.Address.new/1","doc":"","ref":"ExTwilio.Address.html#new/1"},{"type":"function","title":"ExTwilio.Address.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Address.html#parents/0"},{"type":"function","title":"ExTwilio.Address.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Address.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Address.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Address.html#resource_name/0"},{"type":"function","title":"ExTwilio.Address.stream/1","doc":"","ref":"ExTwilio.Address.html#stream/1"},{"type":"function","title":"ExTwilio.Address.update/3","doc":"","ref":"ExTwilio.Address.html#update/3"},{"type":"module","title":"ExTwilio.Api","doc":"Provides a basic HTTP interface to allow easy communication with the Twilio\nAPI, by wrapping `HTTPotion`.","ref":"ExTwilio.Api.html"},{"type":"module","title":"Examples - ExTwilio.Api","doc":"Requests are made to the Twilio API by passing in a resource module into one\nof this `Api` module's functions. The correct URL to the resource is inferred\nfrom the module name.\n\n    ExTwilio.Api.find(Resource, \"sid\")\n    %Resource{ sid: \"sid\", ... }\n\nItems are returned as instances of the given module's struct. For more\ndetails, see the documentation for each function.","ref":"ExTwilio.Api.html#module-examples"},{"type":"function","title":"ExTwilio.Api.auth_header/1","doc":"Builds custom auth header for subaccounts.","ref":"ExTwilio.Api.html#auth_header/1"},{"type":"function","title":"Examples - ExTwilio.Api.auth_header/1","doc":"iex> ExTwilio.Api.auth_header([account: 123, token: 123])\n  [\"Authorization\": \"Basic MTIzOjEyMw==\"]\n\n  iex> ExTwilio.Api.auth_header([], {nil, 2})\n  []","ref":"ExTwilio.Api.html#auth_header/1-examples"},{"type":"function","title":"ExTwilio.Api.auth_header/2","doc":"Builds custom auth header for subaccounts.\n\nHandles master account case if :\"Authorization\" custom header isn't present","ref":"ExTwilio.Api.html#auth_header/2"},{"type":"function","title":"Examples - ExTwilio.Api.auth_header/2","doc":"iex> ExTwilio.Api.auth_header([], {123, 123})\n  [\"Authorization\": \"Basic MTIzOjEyMw==\"]\n\n  iex> ExTwilio.Api.auth_header([\"Authorization\": \"Basic BASE64==\"], {123, 123})\n  [\"Authorization\": \"Basic BASE64==\"]","ref":"ExTwilio.Api.html#auth_header/2-examples"},{"type":"function","title":"ExTwilio.Api.create/3","doc":"Create a new resource in the Twilio API with a POST request.","ref":"ExTwilio.Api.html#create/3"},{"type":"function","title":"Examples - ExTwilio.Api.create/3","doc":"ExTwilio.Api.create(ExTwilio.Call, [to: \"1112223333\", from: \"4445556666\"])\n    {:ok, %Call{ ... }}\n\n    ExTwilio.Api.create(ExTwilio.Call, [])\n    {:error, %{\"message\" => \"No 'To' number is specified\"}, 400}","ref":"ExTwilio.Api.html#create/3-examples"},{"type":"function","title":"ExTwilio.Api.delete/3","doc":"Issues a DELETE request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"ExTwilio.Api.html#delete/3"},{"type":"function","title":"ExTwilio.Api.delete!/3","doc":"Issues a DELETE request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"ExTwilio.Api.html#delete!/3"},{"type":"function","title":"ExTwilio.Api.destroy/3","doc":"Destroy an existing resource in the Twilio Api.","ref":"ExTwilio.Api.html#destroy/3"},{"type":"function","title":"Examples - ExTwilio.Api.destroy/3","doc":"ExTwilio.Api.destroy(ExTwilio.Call, \" \")\n    :ok\n\n    ExTwilio.Api.destroy(ExTwilio.Call, \"nonexistent\")\n    {:error, %{\"message\" => The requested resource ... was not found\"}, 404}","ref":"ExTwilio.Api.html#destroy/3-examples"},{"type":"function","title":"ExTwilio.Api.find/3","doc":"Find a given resource in the Twilio API by its SID.","ref":"ExTwilio.Api.html#find/3"},{"type":"function","title":"Examples - ExTwilio.Api.find/3","doc":"If the resource was found, `find/2` will return a two-element tuple in this\nformat, `{:ok, item}`.\n\n    ExTwilio.Api.find(ExTwilio.Call, \" \")\n    {:ok, %Call{ ... }}\n\nIf the resource could not be loaded, `find/2` will return a 3-element tuple\nin this format, `{:error, error_body, code}`. The `code` is the HTTP status code\nreturned by the Twilio API, for example, 404.\n\n    ExTwilio.Api.find(ExTwilio.Call, \"nonexistent sid\")\n    {:error, %{\"message\" => The requested resource couldn't be found...\"}, 404}","ref":"ExTwilio.Api.html#find/3-examples"},{"type":"function","title":"ExTwilio.Api.format_data/1","doc":"","ref":"ExTwilio.Api.html#format_data/1"},{"type":"function","title":"ExTwilio.Api.get/3","doc":"Issues a GET request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"ExTwilio.Api.html#get/3"},{"type":"function","title":"ExTwilio.Api.get!/3","doc":"Issues a GET request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"ExTwilio.Api.html#get!/3"},{"type":"function","title":"ExTwilio.Api.head/3","doc":"Issues a HEAD request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"ExTwilio.Api.html#head/3"},{"type":"function","title":"ExTwilio.Api.head!/3","doc":"Issues a HEAD request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"ExTwilio.Api.html#head!/3"},{"type":"function","title":"ExTwilio.Api.options/3","doc":"Issues an OPTIONS request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"ExTwilio.Api.html#options/3"},{"type":"function","title":"ExTwilio.Api.options!/3","doc":"Issues a OPTIONS request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"ExTwilio.Api.html#options!/3"},{"type":"function","title":"ExTwilio.Api.patch/4","doc":"Issues a PATCH request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"ExTwilio.Api.html#patch/4"},{"type":"function","title":"ExTwilio.Api.patch!/4","doc":"Issues a PATCH request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"ExTwilio.Api.html#patch!/4"},{"type":"function","title":"ExTwilio.Api.post/4","doc":"Issues a POST request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"ExTwilio.Api.html#post/4"},{"type":"function","title":"ExTwilio.Api.post!/4","doc":"Issues a POST request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"ExTwilio.Api.html#post!/4"},{"type":"function","title":"ExTwilio.Api.process_headers/1","doc":"","ref":"ExTwilio.Api.html#process_headers/1"},{"type":"function","title":"ExTwilio.Api.process_request_body/1","doc":"","ref":"ExTwilio.Api.html#process_request_body/1"},{"type":"function","title":"ExTwilio.Api.process_request_headers/1","doc":"","ref":"ExTwilio.Api.html#process_request_headers/1"},{"type":"function","title":"ExTwilio.Api.process_request_options/1","doc":"","ref":"ExTwilio.Api.html#process_request_options/1"},{"type":"function","title":"ExTwilio.Api.process_request_params/1","doc":"","ref":"ExTwilio.Api.html#process_request_params/1"},{"type":"function","title":"ExTwilio.Api.process_request_url/1","doc":"","ref":"ExTwilio.Api.html#process_request_url/1"},{"type":"function","title":"ExTwilio.Api.process_response/1","doc":"","ref":"ExTwilio.Api.html#process_response/1"},{"type":"function","title":"ExTwilio.Api.process_response_body/1","doc":"","ref":"ExTwilio.Api.html#process_response_body/1"},{"type":"function","title":"ExTwilio.Api.process_response_chunk/1","doc":"","ref":"ExTwilio.Api.html#process_response_chunk/1"},{"type":"function","title":"ExTwilio.Api.process_response_headers/1","doc":"","ref":"ExTwilio.Api.html#process_response_headers/1"},{"type":"function","title":"ExTwilio.Api.process_response_status_code/1","doc":"","ref":"ExTwilio.Api.html#process_response_status_code/1"},{"type":"function","title":"ExTwilio.Api.process_status_code/1","doc":"","ref":"ExTwilio.Api.html#process_status_code/1"},{"type":"function","title":"ExTwilio.Api.process_url/1","doc":"","ref":"ExTwilio.Api.html#process_url/1"},{"type":"function","title":"ExTwilio.Api.put/4","doc":"Issues a PUT request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"ExTwilio.Api.html#put/4"},{"type":"function","title":"ExTwilio.Api.put!/4","doc":"Issues a PUT request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"ExTwilio.Api.html#put!/4"},{"type":"function","title":"ExTwilio.Api.request/1","doc":"Issues an HTTP request using an `HTTPoison.Request` struct.\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"ExTwilio.Api.html#request/1"},{"type":"function","title":"Redirect handling - ExTwilio.Api.request/1","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"ExTwilio.Api.html#request/1-redirect-handling"},{"type":"function","title":"Examples - ExTwilio.Api.request/1","doc":"request = %HTTPoison.Request{\n      method: :post,\n      url: \"https://my.website.com\",\n      body: \"{\\\"foo\\\": 3}\",\n      headers: [{\"Accept\", \"application/json\"}]\n    }\n\n    request(request)","ref":"ExTwilio.Api.html#request/1-examples"},{"type":"function","title":"ExTwilio.Api.request/5","doc":"Issues an HTTP request with the given method to the given url.\n\nThis function is usually used indirectly by `get/3`, `post/4`, `put/4`, etc\n\nArgs:\n  * `method` - HTTP method as an atom (`:get`, `:head`, `:post`, `:put`,\n    `:delete`, etc.)\n  * `url` - target url as a binary string or char list\n  * `body` - request body. See more below\n  * `headers` - HTTP headers as an orddict (e.g., `[{\"Accept\", \"application/json\"}]`)\n  * `options` - Keyword list of options\n\nBody: see type `HTTPoison.Request`\n\nOptions: see type `HTTPoison.Request`\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"ExTwilio.Api.html#request/5"},{"type":"function","title":"Redirect handling - ExTwilio.Api.request/5","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"ExTwilio.Api.html#request/5-redirect-handling"},{"type":"function","title":"Examples - ExTwilio.Api.request/5","doc":"request(:post, \"https://my.website.com\", \"{\\\"foo\\\": 3}\", [{\"Accept\", \"application/json\"}])","ref":"ExTwilio.Api.html#request/5-examples"},{"type":"function","title":"ExTwilio.Api.request!/1","doc":"Issues an HTTP request an `HTTPoison.Request` struct.\nexception in case of failure.\n\n`request!/1` works exactly like `request/1` but it returns just the\nresponse in case of a successful request, raising an exception in case the\nrequest fails.","ref":"ExTwilio.Api.html#request!/1"},{"type":"function","title":"ExTwilio.Api.request!/5","doc":"Issues an HTTP request with the given method to the given url, raising an\nexception in case of failure.\n\n`request!/5` works exactly like `request/5` but it returns just the\nresponse in case of a successful request, raising an exception in case the\nrequest fails.","ref":"ExTwilio.Api.html#request!/5"},{"type":"function","title":"ExTwilio.Api.start/0","doc":"Starts HTTPoison and its dependencies.","ref":"ExTwilio.Api.html#start/0"},{"type":"function","title":"ExTwilio.Api.stream_next/1","doc":"Requests the next message to be streamed for a given `HTTPoison.AsyncResponse`.\n\nSee `request!/5` for more detailed information.","ref":"ExTwilio.Api.html#stream_next/1"},{"type":"function","title":"ExTwilio.Api.update/4","doc":"Update an existing resource in the Twilio Api.","ref":"ExTwilio.Api.html#update/4"},{"type":"function","title":"Examples - ExTwilio.Api.update/4","doc":"ExTwilio.Api.update(ExTwilio.Call, \" \", [status: \"canceled\"])\n    {:ok, %Call{ status: \"canceled\" ... }}\n\n    ExTwilio.Api.update(ExTwilio.Call, \"nonexistent\", [status: \"complete\"])\n    {:error, %{\"message\" => \"The requested resource ... was not found\"}, 404}","ref":"ExTwilio.Api.html#update/4-examples"},{"type":"type","title":"ExTwilio.Api.body/0","doc":"","ref":"ExTwilio.Api.html#t:body/0"},{"type":"type","title":"ExTwilio.Api.data/0","doc":"","ref":"ExTwilio.Api.html#t:data/0"},{"type":"type","title":"ExTwilio.Api.headers/0","doc":"","ref":"ExTwilio.Api.html#t:headers/0"},{"type":"type","title":"ExTwilio.Api.method/0","doc":"","ref":"ExTwilio.Api.html#t:method/0"},{"type":"type","title":"ExTwilio.Api.options/0","doc":"","ref":"ExTwilio.Api.html#t:options/0"},{"type":"type","title":"ExTwilio.Api.params/0","doc":"","ref":"ExTwilio.Api.html#t:params/0"},{"type":"type","title":"ExTwilio.Api.request/0","doc":"","ref":"ExTwilio.Api.html#t:request/0"},{"type":"type","title":"ExTwilio.Api.url/0","doc":"","ref":"ExTwilio.Api.html#t:url/0"},{"type":"module","title":"ExTwilio.Application","doc":"Represents an Application resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/usage/api/applications)","ref":"ExTwilio.Application.html"},{"type":"function","title":"ExTwilio.Application.all/1","doc":"","ref":"ExTwilio.Application.html#all/1"},{"type":"function","title":"ExTwilio.Application.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Application.html#children/0"},{"type":"function","title":"ExTwilio.Application.create/2","doc":"","ref":"ExTwilio.Application.html#create/2"},{"type":"function","title":"ExTwilio.Application.destroy/2","doc":"","ref":"ExTwilio.Application.html#destroy/2"},{"type":"function","title":"ExTwilio.Application.do_new/2","doc":"","ref":"ExTwilio.Application.html#do_new/2"},{"type":"function","title":"ExTwilio.Application.find/2","doc":"","ref":"ExTwilio.Application.html#find/2"},{"type":"function","title":"ExTwilio.Application.new/0","doc":"","ref":"ExTwilio.Application.html#new/0"},{"type":"function","title":"ExTwilio.Application.new/1","doc":"","ref":"ExTwilio.Application.html#new/1"},{"type":"function","title":"ExTwilio.Application.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Application.html#parents/0"},{"type":"function","title":"ExTwilio.Application.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Application.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Application.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Application.html#resource_name/0"},{"type":"function","title":"ExTwilio.Application.stream/1","doc":"","ref":"ExTwilio.Application.html#stream/1"},{"type":"function","title":"ExTwilio.Application.update/3","doc":"","ref":"ExTwilio.Application.html#update/3"},{"type":"module","title":"ExTwilio.AuthorizedConnectApp","doc":"Represents an AuthorizedConnectApp resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/iam/authorized-connect-apps/api)","ref":"ExTwilio.AuthorizedConnectApp.html"},{"type":"function","title":"ExTwilio.AuthorizedConnectApp.all/1","doc":"","ref":"ExTwilio.AuthorizedConnectApp.html#all/1"},{"type":"function","title":"ExTwilio.AuthorizedConnectApp.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.AuthorizedConnectApp.html#children/0"},{"type":"function","title":"ExTwilio.AuthorizedConnectApp.do_new/2","doc":"","ref":"ExTwilio.AuthorizedConnectApp.html#do_new/2"},{"type":"function","title":"ExTwilio.AuthorizedConnectApp.find/2","doc":"","ref":"ExTwilio.AuthorizedConnectApp.html#find/2"},{"type":"function","title":"ExTwilio.AuthorizedConnectApp.new/0","doc":"","ref":"ExTwilio.AuthorizedConnectApp.html#new/0"},{"type":"function","title":"ExTwilio.AuthorizedConnectApp.new/1","doc":"","ref":"ExTwilio.AuthorizedConnectApp.html#new/1"},{"type":"function","title":"ExTwilio.AuthorizedConnectApp.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.AuthorizedConnectApp.html#parents/0"},{"type":"function","title":"ExTwilio.AuthorizedConnectApp.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.AuthorizedConnectApp.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.AuthorizedConnectApp.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.AuthorizedConnectApp.html#resource_name/0"},{"type":"function","title":"ExTwilio.AuthorizedConnectApp.stream/1","doc":"","ref":"ExTwilio.AuthorizedConnectApp.html#stream/1"},{"type":"module","title":"ExTwilio.AvailablePhoneNumber","doc":"Represents an AvailablePhoneNumber resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/phone-numbers/api/availablephonenumber-resource)","ref":"ExTwilio.AvailablePhoneNumber.html"},{"type":"function","title":"ExTwilio.AvailablePhoneNumber.all/1","doc":"","ref":"ExTwilio.AvailablePhoneNumber.html#all/1"},{"type":"function","title":"ExTwilio.AvailablePhoneNumber.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.AvailablePhoneNumber.html#children/0"},{"type":"function","title":"ExTwilio.AvailablePhoneNumber.do_new/2","doc":"","ref":"ExTwilio.AvailablePhoneNumber.html#do_new/2"},{"type":"function","title":"ExTwilio.AvailablePhoneNumber.new/0","doc":"","ref":"ExTwilio.AvailablePhoneNumber.html#new/0"},{"type":"function","title":"ExTwilio.AvailablePhoneNumber.new/1","doc":"","ref":"ExTwilio.AvailablePhoneNumber.html#new/1"},{"type":"function","title":"ExTwilio.AvailablePhoneNumber.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.AvailablePhoneNumber.html#parents/0"},{"type":"function","title":"ExTwilio.AvailablePhoneNumber.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.AvailablePhoneNumber.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.AvailablePhoneNumber.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.AvailablePhoneNumber.html#resource_name/0"},{"type":"function","title":"ExTwilio.AvailablePhoneNumber.stream/1","doc":"","ref":"ExTwilio.AvailablePhoneNumber.html#stream/1"},{"type":"module","title":"ExTwilio.Call","doc":"Represents an Call resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/voice/api/call-resource)","ref":"ExTwilio.Call.html"},{"type":"function","title":"ExTwilio.Call.all/1","doc":"","ref":"ExTwilio.Call.html#all/1"},{"type":"function","title":"ExTwilio.Call.cancel/1","doc":"","ref":"ExTwilio.Call.html#cancel/1"},{"type":"function","title":"ExTwilio.Call.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Call.html#children/0"},{"type":"function","title":"ExTwilio.Call.complete/1","doc":"","ref":"ExTwilio.Call.html#complete/1"},{"type":"function","title":"ExTwilio.Call.create/2","doc":"","ref":"ExTwilio.Call.html#create/2"},{"type":"function","title":"ExTwilio.Call.destroy/2","doc":"","ref":"ExTwilio.Call.html#destroy/2"},{"type":"function","title":"ExTwilio.Call.do_new/2","doc":"","ref":"ExTwilio.Call.html#do_new/2"},{"type":"function","title":"ExTwilio.Call.find/2","doc":"","ref":"ExTwilio.Call.html#find/2"},{"type":"function","title":"ExTwilio.Call.new/0","doc":"","ref":"ExTwilio.Call.html#new/0"},{"type":"function","title":"ExTwilio.Call.new/1","doc":"","ref":"ExTwilio.Call.html#new/1"},{"type":"function","title":"ExTwilio.Call.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Call.html#parents/0"},{"type":"function","title":"ExTwilio.Call.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Call.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Call.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Call.html#resource_name/0"},{"type":"function","title":"ExTwilio.Call.stream/1","doc":"","ref":"ExTwilio.Call.html#stream/1"},{"type":"function","title":"ExTwilio.Call.update/3","doc":"","ref":"ExTwilio.Call.html#update/3"},{"type":"module","title":"ExTwilio.Capability","doc":"Capability tokens are used to sign communications from devices\nto Twilio.\n\nYou create a token on your server, specify what capabilities you would like\nyour device to have, then pass the token to your client to use. The tokens\ngenerated are JSON Web Tokens (JWT).\n\n- [Capability docs](https://www.twilio.com/docs/api/client/capability-tokens)\n- [JWT docs](https://jwt.io/introduction/)","ref":"ExTwilio.Capability.html"},{"type":"module","title":"Examples - ExTwilio.Capability","doc":"ExTwilio.Capability.new\n    |> ExTwilio.Capability.allow_client_incoming(\"tommy\")\n    |> ExTwilio.Capability.allow_client_outgoing(\"APabe7650f654fc34655fc81ae71caa3ff\")\n    |> ExTwilio.Capability.token\n    \"xxxxx.yyyyy.zzzzz\"","ref":"ExTwilio.Capability.html#module-examples"},{"type":"function","title":"ExTwilio.Capability.allow_client_incoming/1","doc":"Gives the device a client name allowing incoming connections\nto the client identified by the provided `client_name`.\n\n- [Incoming capability docs](https://www.twilio.com/docs/api/client/capability-tokens#allow-incoming-connections)","ref":"ExTwilio.Capability.html#allow_client_incoming/1"},{"type":"function","title":"Examples - ExTwilio.Capability.allow_client_incoming/1","doc":"A device with this token will be identified as `tommy`\n\n    ExTwilio.Capability.allow_client_incoming(\"tommy\")","ref":"ExTwilio.Capability.html#allow_client_incoming/1-examples"},{"type":"function","title":"ExTwilio.Capability.allow_client_incoming/2","doc":"","ref":"ExTwilio.Capability.html#allow_client_incoming/2"},{"type":"function","title":"ExTwilio.Capability.allow_client_outgoing/1","doc":"Gives the device an application sid so that Twilio can\ndetermine the voice URL to use to handle any outgoing\nconnection.\n\n- [Outgoing capability docs](https://www.twilio.com/docs/api/client/capability-tokens#allow-outgoing-connections)","ref":"ExTwilio.Capability.html#allow_client_outgoing/1"},{"type":"function","title":"Examples - ExTwilio.Capability.allow_client_outgoing/1","doc":"Outgoing connections will use the Twilio application with the\nSID: `APabe7650f654fc34655fc81ae71caa3ff`\n\n    ExTwilio.Capability.allow_client_outgoing(\"APabe7650f654fc34655fc81ae71caa3ff\")","ref":"ExTwilio.Capability.html#allow_client_outgoing/1-examples"},{"type":"function","title":"ExTwilio.Capability.allow_client_outgoing/2","doc":"","ref":"ExTwilio.Capability.html#allow_client_outgoing/2"},{"type":"function","title":"ExTwilio.Capability.allow_client_outgoing/3","doc":"","ref":"ExTwilio.Capability.html#allow_client_outgoing/3"},{"type":"function","title":"ExTwilio.Capability.generate_and_sign/2","doc":"Combines `generate_claims/1` and `encode_and_sign/2`","ref":"ExTwilio.Capability.html#generate_and_sign/2"},{"type":"function","title":"ExTwilio.Capability.generate_and_sign!/2","doc":"Same as `generate_and_sign/2` but raises if error","ref":"ExTwilio.Capability.html#generate_and_sign!/2"},{"type":"function","title":"ExTwilio.Capability.new/0","doc":"Initialises a new capability specification with a TTL of one hour,\nand the account sid and auth token taken from the configuration.","ref":"ExTwilio.Capability.html#new/0"},{"type":"function","title":"Examples - ExTwilio.Capability.new/0","doc":"ExTwilio.Capability.new","ref":"ExTwilio.Capability.html#new/0-examples"},{"type":"function","title":"ExTwilio.Capability.starting_at/2","doc":"Sets the time at which the TTL begins in seconds since epoch.","ref":"ExTwilio.Capability.html#starting_at/2"},{"type":"function","title":"Examples - ExTwilio.Capability.starting_at/2","doc":"Sets the TTL to begin on 24th May, 2016\n\n    ExTwilio.Capability.starting_at(1464096368)","ref":"ExTwilio.Capability.html#starting_at/2-examples"},{"type":"function","title":"ExTwilio.Capability.token/1","doc":"Generates a JWT token based on the requested capabilities\nthat can be provided to the Twilio client. Supports clients\nwith multiple capabilties.\n\n- [Multiple capability docs](https://www.twilio.com/docs/api/client/capability-tokens#multiple-capabilities)","ref":"ExTwilio.Capability.html#token/1"},{"type":"function","title":"Examples - ExTwilio.Capability.token/1","doc":"Generates and signs a token with the provided capabilities\n\n    ExTwilio.Capability.token","ref":"ExTwilio.Capability.html#token/1-examples"},{"type":"function","title":"ExTwilio.Capability.verify_and_validate/3","doc":"Combines `verify/2` and `validate/2`","ref":"ExTwilio.Capability.html#verify_and_validate/3"},{"type":"function","title":"ExTwilio.Capability.verify_and_validate!/3","doc":"Same as `verify_and_validate/2` but raises if error","ref":"ExTwilio.Capability.html#verify_and_validate!/3"},{"type":"function","title":"ExTwilio.Capability.with_account_sid/2","doc":"Sets the Twilio account sid used to issue the token.","ref":"ExTwilio.Capability.html#with_account_sid/2"},{"type":"function","title":"Examples - ExTwilio.Capability.with_account_sid/2","doc":"Sets the account sid to be XXX\n\n    ExTwilio.Capability.with_account_sid('XXX')","ref":"ExTwilio.Capability.html#with_account_sid/2-examples"},{"type":"function","title":"ExTwilio.Capability.with_auth_token/2","doc":"Sets the Twilio account auth token used to sign the capability token.","ref":"ExTwilio.Capability.html#with_auth_token/2"},{"type":"function","title":"Examples - ExTwilio.Capability.with_auth_token/2","doc":"Sets the auth token to be XXX\n\n    ExTwilio.Capability.with_auth_token('XXX')","ref":"ExTwilio.Capability.html#with_auth_token/2-examples"},{"type":"function","title":"ExTwilio.Capability.with_ttl/2","doc":"Sets the TTL of the token in seconds.\n\n- [TTL docs](https://www.twilio.com/docs/api/client/capability-tokens#token-expiration)","ref":"ExTwilio.Capability.html#with_ttl/2"},{"type":"function","title":"Examples - ExTwilio.Capability.with_ttl/2","doc":"Sets the TTL to one hour\n\n    ExTwilio.Capability.with_ttl(3600)","ref":"ExTwilio.Capability.html#with_ttl/2-examples"},{"type":"type","title":"ExTwilio.Capability.outgoing_client_app/0","doc":"","ref":"ExTwilio.Capability.html#t:outgoing_client_app/0"},{"type":"type","title":"ExTwilio.Capability.t/0","doc":"","ref":"ExTwilio.Capability.html#t:t/0"},{"type":"module","title":"ExTwilio.Conference","doc":"Represents an Conference resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/voice/api/conference-resource)","ref":"ExTwilio.Conference.html"},{"type":"function","title":"ExTwilio.Conference.all/1","doc":"","ref":"ExTwilio.Conference.html#all/1"},{"type":"function","title":"ExTwilio.Conference.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Conference.html#children/0"},{"type":"function","title":"ExTwilio.Conference.do_new/2","doc":"","ref":"ExTwilio.Conference.html#do_new/2"},{"type":"function","title":"ExTwilio.Conference.find/2","doc":"","ref":"ExTwilio.Conference.html#find/2"},{"type":"function","title":"ExTwilio.Conference.new/0","doc":"","ref":"ExTwilio.Conference.html#new/0"},{"type":"function","title":"ExTwilio.Conference.new/1","doc":"","ref":"ExTwilio.Conference.html#new/1"},{"type":"function","title":"ExTwilio.Conference.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Conference.html#parents/0"},{"type":"function","title":"ExTwilio.Conference.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Conference.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Conference.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Conference.html#resource_name/0"},{"type":"function","title":"ExTwilio.Conference.stream/1","doc":"","ref":"ExTwilio.Conference.html#stream/1"},{"type":"function","title":"ExTwilio.Conference.update/3","doc":"","ref":"ExTwilio.Conference.html#update/3"},{"type":"module","title":"ExTwilio.Config","doc":"Stores configuration variables used to communicate with Twilio's API.\n\nAll settings also accept `{:system, \"ENV_VAR_NAME\"}` to read their\nvalues from environment variables at runtime.","ref":"ExTwilio.Config.html"},{"type":"function","title":"ExTwilio.Config.account_sid/0","doc":"Returns the Twilio Account SID. Set it in `mix.exs`:\n\n    config :ex_twilio, account_sid: \"YOUR_ACCOUNT_SID\"","ref":"ExTwilio.Config.html#account_sid/0"},{"type":"function","title":"ExTwilio.Config.api_domain/0","doc":"Returns the domain of the Twilio API. This will default to \"api.twilio.com\",\nbut can be overridden using the following setting in `mix.exs`:\n\n    config :ex_twilio, api_domain: \"other.twilio.com\"","ref":"ExTwilio.Config.html#api_domain/0"},{"type":"function","title":"ExTwilio.Config.api_version/0","doc":"Returns the version of the API that ExTwilio is going to talk to. Set it in\n`mix.exs`:\n    config :ex_twilio, api_version: \"2015-05-06\"","ref":"ExTwilio.Config.html#api_version/0"},{"type":"function","title":"ExTwilio.Config.auth_token/0","doc":"Returns the Twilio Auth Token for your account. Set it in `mix.exs`:\n\n    config :ex_twilio, auth_token: \"YOUR_AUTH_TOKEN\"","ref":"ExTwilio.Config.html#auth_token/0"},{"type":"function","title":"ExTwilio.Config.base_url/0","doc":"Return the combined base URL of the Twilio API, using the configuration\nsettings given.","ref":"ExTwilio.Config.html#base_url/0"},{"type":"function","title":"ExTwilio.Config.fax_url/0","doc":"","ref":"ExTwilio.Config.html#fax_url/0"},{"type":"function","title":"ExTwilio.Config.from_env/3","doc":"A light wrapper around `Application.get_env/2`, providing automatic support for\n`{:system, \"VAR\"}` tuples.","ref":"ExTwilio.Config.html#from_env/3"},{"type":"function","title":"ExTwilio.Config.notify_url/0","doc":"","ref":"ExTwilio.Config.html#notify_url/0"},{"type":"function","title":"ExTwilio.Config.programmable_chat_url/0","doc":"","ref":"ExTwilio.Config.html#programmable_chat_url/0"},{"type":"function","title":"ExTwilio.Config.protocol/0","doc":"Returns the protocol used for the Twilio API. The default is `\"https\"` for\ninteracting with the Twilio API, but when testing with Bypass, you may want\nthis to be `\"http\"`.","ref":"ExTwilio.Config.html#protocol/0"},{"type":"function","title":"ExTwilio.Config.request_options/0","doc":"Options added to HTTPoison requests","ref":"ExTwilio.Config.html#request_options/0"},{"type":"function","title":"ExTwilio.Config.studio_url/0","doc":"","ref":"ExTwilio.Config.html#studio_url/0"},{"type":"function","title":"ExTwilio.Config.task_router_url/0","doc":"","ref":"ExTwilio.Config.html#task_router_url/0"},{"type":"function","title":"ExTwilio.Config.task_router_websocket_base_url/0","doc":"","ref":"ExTwilio.Config.html#task_router_websocket_base_url/0"},{"type":"function","title":"ExTwilio.Config.video_url/0","doc":"","ref":"ExTwilio.Config.html#video_url/0"},{"type":"function","title":"ExTwilio.Config.workspace_sid/0","doc":"","ref":"ExTwilio.Config.html#workspace_sid/0"},{"type":"module","title":"ExTwilio.ConnectApp","doc":"Represents an ConnectApp resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/iam/connect-apps/api)","ref":"ExTwilio.ConnectApp.html"},{"type":"function","title":"ExTwilio.ConnectApp.all/1","doc":"","ref":"ExTwilio.ConnectApp.html#all/1"},{"type":"function","title":"ExTwilio.ConnectApp.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.ConnectApp.html#children/0"},{"type":"function","title":"ExTwilio.ConnectApp.create/2","doc":"","ref":"ExTwilio.ConnectApp.html#create/2"},{"type":"function","title":"ExTwilio.ConnectApp.do_new/2","doc":"","ref":"ExTwilio.ConnectApp.html#do_new/2"},{"type":"function","title":"ExTwilio.ConnectApp.find/2","doc":"","ref":"ExTwilio.ConnectApp.html#find/2"},{"type":"function","title":"ExTwilio.ConnectApp.new/0","doc":"","ref":"ExTwilio.ConnectApp.html#new/0"},{"type":"function","title":"ExTwilio.ConnectApp.new/1","doc":"","ref":"ExTwilio.ConnectApp.html#new/1"},{"type":"function","title":"ExTwilio.ConnectApp.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.ConnectApp.html#parents/0"},{"type":"function","title":"ExTwilio.ConnectApp.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ConnectApp.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.ConnectApp.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ConnectApp.html#resource_name/0"},{"type":"function","title":"ExTwilio.ConnectApp.stream/1","doc":"","ref":"ExTwilio.ConnectApp.html#stream/1"},{"type":"function","title":"ExTwilio.ConnectApp.update/3","doc":"","ref":"ExTwilio.ConnectApp.html#update/3"},{"type":"module","title":"ExTwilio.DependentPhoneNumber","doc":"Represents an DependentPhoneNumber resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/usage/api/address#list-dependent-pns)","ref":"ExTwilio.DependentPhoneNumber.html"},{"type":"module","title":"Examples - ExTwilio.DependentPhoneNumber","doc":"Since DependentPhoneNumbers are a nested resource in the Twilio API, you must\npass in a parent Address SID to all functions in this module.\n\n    ExTwilio.DependentPhoneNumber.all(address: \"address_sid\")","ref":"ExTwilio.DependentPhoneNumber.html#module-examples"},{"type":"function","title":"ExTwilio.DependentPhoneNumber.all/1","doc":"","ref":"ExTwilio.DependentPhoneNumber.html#all/1"},{"type":"function","title":"ExTwilio.DependentPhoneNumber.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.DependentPhoneNumber.html#children/0"},{"type":"function","title":"ExTwilio.DependentPhoneNumber.do_new/2","doc":"","ref":"ExTwilio.DependentPhoneNumber.html#do_new/2"},{"type":"function","title":"ExTwilio.DependentPhoneNumber.new/0","doc":"","ref":"ExTwilio.DependentPhoneNumber.html#new/0"},{"type":"function","title":"ExTwilio.DependentPhoneNumber.new/1","doc":"","ref":"ExTwilio.DependentPhoneNumber.html#new/1"},{"type":"function","title":"ExTwilio.DependentPhoneNumber.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.DependentPhoneNumber.html#parents/0"},{"type":"function","title":"ExTwilio.DependentPhoneNumber.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.DependentPhoneNumber.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.DependentPhoneNumber.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.DependentPhoneNumber.html#resource_name/0"},{"type":"function","title":"ExTwilio.DependentPhoneNumber.stream/1","doc":"","ref":"ExTwilio.DependentPhoneNumber.html#stream/1"},{"type":"module","title":"ExTwilio.Ext.Map","doc":"Additional helper functions for working with maps.","ref":"ExTwilio.Ext.Map.html"},{"type":"function","title":"ExTwilio.Ext.Map.put_if/3","doc":"Puts a given key/value pair into a map, if the value is not `false` or `nil`.","ref":"ExTwilio.Ext.Map.html#put_if/3"},{"type":"function","title":"ExTwilio.Ext.Map.validate!/4","doc":"Validates that a function returns true on the given map field, otherwise\nraises an error.","ref":"ExTwilio.Ext.Map.html#validate!/4"},{"type":"type","title":"ExTwilio.Ext.Map.key/0","doc":"","ref":"ExTwilio.Ext.Map.html#t:key/0"},{"type":"module","title":"ExTwilio.Fax","doc":"Warning! currently in Public beta.\n\nRepresents a Fax resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/fax/api)\n\nHere is an example of sending an SMS message:\n\n    ExTwilio.Fax.create(\n      to: \"+15558675310\",\n      from: \"+15017122661\",\n      media_url: \"https://www.twilio.com/docs/documents/25/justthefaxmaam.pdf\"\n    )","ref":"ExTwilio.Fax.html"},{"type":"function","title":"ExTwilio.Fax.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Fax.html#children/0"},{"type":"function","title":"ExTwilio.Fax.create/2","doc":"","ref":"ExTwilio.Fax.html#create/2"},{"type":"function","title":"ExTwilio.Fax.do_new/2","doc":"","ref":"ExTwilio.Fax.html#do_new/2"},{"type":"function","title":"ExTwilio.Fax.find/2","doc":"","ref":"ExTwilio.Fax.html#find/2"},{"type":"function","title":"ExTwilio.Fax.new/0","doc":"","ref":"ExTwilio.Fax.html#new/0"},{"type":"function","title":"ExTwilio.Fax.new/1","doc":"","ref":"ExTwilio.Fax.html#new/1"},{"type":"function","title":"ExTwilio.Fax.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Fax.html#parents/0"},{"type":"function","title":"ExTwilio.Fax.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Fax.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Fax.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Fax.html#resource_name/0"},{"type":"function","title":"ExTwilio.Fax.stream/1","doc":"","ref":"ExTwilio.Fax.html#stream/1"},{"type":"module","title":"ExTwilio.Feedback","doc":"Represents a Call Feedback resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/voice/api/feedback-resource)","ref":"ExTwilio.Feedback.html"},{"type":"module","title":"Examples - ExTwilio.Feedback","doc":"Since Call Feedback is a nested resource in the Twilio API, you must\npass in a parent Call SID to all functions in this module.\n\n    ExTwilio.Feedback.create([quality_score: 5], [call: \"call_sid\"])\n    ExTwilio.Feedback.find(call: \"call_sid\")","ref":"ExTwilio.Feedback.html#module-examples"},{"type":"function","title":"ExTwilio.Feedback.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Feedback.html#children/0"},{"type":"function","title":"ExTwilio.Feedback.create/2","doc":"","ref":"ExTwilio.Feedback.html#create/2"},{"type":"function","title":"ExTwilio.Feedback.do_new/2","doc":"","ref":"ExTwilio.Feedback.html#do_new/2"},{"type":"function","title":"ExTwilio.Feedback.find/1","doc":"Find feedback for a given call. Any options other than `[call: \"sid\"]` will\nresult in a `FunctionClauseError`.","ref":"ExTwilio.Feedback.html#find/1"},{"type":"function","title":"Examples - ExTwilio.Feedback.find/1","doc":"ExTwilio.Feedback.find(call: \"sid\")\n    %ExTwilio.Feedback{issues: [], quality_score: 5}","ref":"ExTwilio.Feedback.html#find/1-examples"},{"type":"function","title":"ExTwilio.Feedback.new/0","doc":"","ref":"ExTwilio.Feedback.html#new/0"},{"type":"function","title":"ExTwilio.Feedback.new/1","doc":"","ref":"ExTwilio.Feedback.html#new/1"},{"type":"function","title":"ExTwilio.Feedback.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Feedback.html#parents/0"},{"type":"function","title":"ExTwilio.Feedback.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Feedback.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Feedback.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Feedback.html#resource_name/0"},{"type":"module","title":"ExTwilio.IncomingPhoneNumber","doc":"Represents an IncomingPhoneNumber resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/phone-numbers/api/incomingphonenumber-resource)","ref":"ExTwilio.IncomingPhoneNumber.html"},{"type":"function","title":"ExTwilio.IncomingPhoneNumber.all/1","doc":"","ref":"ExTwilio.IncomingPhoneNumber.html#all/1"},{"type":"function","title":"ExTwilio.IncomingPhoneNumber.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.IncomingPhoneNumber.html#children/0"},{"type":"function","title":"ExTwilio.IncomingPhoneNumber.create/2","doc":"","ref":"ExTwilio.IncomingPhoneNumber.html#create/2"},{"type":"function","title":"ExTwilio.IncomingPhoneNumber.destroy/2","doc":"","ref":"ExTwilio.IncomingPhoneNumber.html#destroy/2"},{"type":"function","title":"ExTwilio.IncomingPhoneNumber.do_new/2","doc":"","ref":"ExTwilio.IncomingPhoneNumber.html#do_new/2"},{"type":"function","title":"ExTwilio.IncomingPhoneNumber.find/2","doc":"","ref":"ExTwilio.IncomingPhoneNumber.html#find/2"},{"type":"function","title":"ExTwilio.IncomingPhoneNumber.new/0","doc":"","ref":"ExTwilio.IncomingPhoneNumber.html#new/0"},{"type":"function","title":"ExTwilio.IncomingPhoneNumber.new/1","doc":"","ref":"ExTwilio.IncomingPhoneNumber.html#new/1"},{"type":"function","title":"ExTwilio.IncomingPhoneNumber.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.IncomingPhoneNumber.html#parents/0"},{"type":"function","title":"ExTwilio.IncomingPhoneNumber.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.IncomingPhoneNumber.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.IncomingPhoneNumber.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.IncomingPhoneNumber.html#resource_name/0"},{"type":"function","title":"ExTwilio.IncomingPhoneNumber.stream/1","doc":"","ref":"ExTwilio.IncomingPhoneNumber.html#stream/1"},{"type":"function","title":"ExTwilio.IncomingPhoneNumber.update/3","doc":"","ref":"ExTwilio.IncomingPhoneNumber.html#update/3"},{"type":"module","title":"ExTwilio.JWT.AccessToken","doc":"A Twilio JWT access token, as described in the Twilio docs.\n\nhttps://www.twilio.com/docs/iam/access-tokens","ref":"ExTwilio.JWT.AccessToken.html"},{"type":"function","title":"ExTwilio.JWT.AccessToken.generate_and_sign/2","doc":"Combines `generate_claims/1` and `encode_and_sign/2`","ref":"ExTwilio.JWT.AccessToken.html#generate_and_sign/2"},{"type":"function","title":"ExTwilio.JWT.AccessToken.generate_and_sign!/2","doc":"Same as `generate_and_sign/2` but raises if error","ref":"ExTwilio.JWT.AccessToken.html#generate_and_sign!/2"},{"type":"function","title":"ExTwilio.JWT.AccessToken.new/1","doc":"Creates a new JWT access token.","ref":"ExTwilio.JWT.AccessToken.html#new/1"},{"type":"function","title":"Examples - ExTwilio.JWT.AccessToken.new/1","doc":"AccessToken.new(\n      account_sid: \"account_sid\",\n      api_key: \"api_key\",\n      api_secret: \"secret\",\n      identity: \"user@email.com\",\n      expires_in: 86_400,\n      grants: [AccessToken.ChatGrant.new(service_sid: \"sid\")]\n    )","ref":"ExTwilio.JWT.AccessToken.html#new/1-examples"},{"type":"function","title":"ExTwilio.JWT.AccessToken.to_jwt!/1","doc":"Converts an access token into a string JWT.\n\nWill raise errors if the `token` does not have all the required fields.","ref":"ExTwilio.JWT.AccessToken.html#to_jwt!/1"},{"type":"function","title":"Examples - ExTwilio.JWT.AccessToken.to_jwt!/1","doc":"token =\n      AccessToken.new(\n        account_sid: \"account_sid\",\n        api_key: \"api_key\",\n        api_secret: \"secret\",\n        identity: \"user@email.com\",\n        expires_in: 86_400,\n        grants: [AccessToken.ChatGrant.new(service_sid: \"sid\")]\n      )\n\n    AccessToken.to_jwt!(token)\n    # => \"eyJhbGciOiJIUzI1NiIsImN0eSI6InR3aWxpby1mcGE7dj0xIiwidHlwIjoiSldUIn0.eyJleHAiOjE1MjM5MTIxODgsImdyYW50cyI6eyJjaGF0Ijp7ImVuZHBvaW50X2lkIjpudWxsLCJzZXJ2aWNlX3NpZCI6InNpZCJ9LCJpZGVudGl0eSI6InVzZXJAZW1haWwuY29tIn0sImlhdCI6MTUyMzkwNDk4OCwibmJmIjoxNTIzOTA0OTg3fQ.M_5dsj1VWBrIZKvcIdygSpmiMsrZdkplYYNjxEhBHk0\"","ref":"ExTwilio.JWT.AccessToken.html#to_jwt!/1-examples"},{"type":"function","title":"ExTwilio.JWT.AccessToken.verify_and_validate/3","doc":"Combines `verify/2` and `validate/2`","ref":"ExTwilio.JWT.AccessToken.html#verify_and_validate/3"},{"type":"function","title":"ExTwilio.JWT.AccessToken.verify_and_validate!/3","doc":"Same as `verify_and_validate/2` but raises if error","ref":"ExTwilio.JWT.AccessToken.html#verify_and_validate!/3"},{"type":"type","title":"ExTwilio.JWT.AccessToken.t/0","doc":"","ref":"ExTwilio.JWT.AccessToken.html#t:t/0"},{"type":"module","title":"ExTwilio.JWT.AccessToken.ChatGrant","doc":"A JWT grant to access a given Twilio chat service.","ref":"ExTwilio.JWT.AccessToken.ChatGrant.html"},{"type":"module","title":"Examples - ExTwilio.JWT.AccessToken.ChatGrant","doc":"ExTwilio.JWT.AccessToken.ChatGrant.new(\n      service_sid: \"sid\",\n      endpoint_id: \"123\",\n      deployment_role_sid: \"sid\",\n      push_credential_sid: \"sid\"\n    )","ref":"ExTwilio.JWT.AccessToken.ChatGrant.html#module-examples"},{"type":"function","title":"ExTwilio.JWT.AccessToken.ChatGrant.new/1","doc":"Create a new grant.","ref":"ExTwilio.JWT.AccessToken.ChatGrant.html#new/1"},{"type":"type","title":"ExTwilio.JWT.AccessToken.ChatGrant.t/0","doc":"","ref":"ExTwilio.JWT.AccessToken.ChatGrant.html#t:t/0"},{"type":"module","title":"ExTwilio.JWT.AccessToken.VideoGrant","doc":"A JWT grant to access a given Twilio video service.","ref":"ExTwilio.JWT.AccessToken.VideoGrant.html"},{"type":"module","title":"Examples - ExTwilio.JWT.AccessToken.VideoGrant","doc":"ExTwilio.JWT.AccessToken.VideoGrant.new(room: \"room_id\")","ref":"ExTwilio.JWT.AccessToken.VideoGrant.html#module-examples"},{"type":"function","title":"ExTwilio.JWT.AccessToken.VideoGrant.new/1","doc":"Create a new grant.","ref":"ExTwilio.JWT.AccessToken.VideoGrant.html#new/1"},{"type":"type","title":"ExTwilio.JWT.AccessToken.VideoGrant.t/0","doc":"","ref":"ExTwilio.JWT.AccessToken.VideoGrant.html#t:t/0"},{"type":"module","title":"ExTwilio.JWT.AccessToken.VoiceGrant","doc":"A JWT grant to access a given Twilio voice service.","ref":"ExTwilio.JWT.AccessToken.VoiceGrant.html"},{"type":"module","title":"Examples - ExTwilio.JWT.AccessToken.VoiceGrant","doc":"ExTwilio.JWT.AccessToken.VoiceGrant.new(\n      outgoing_application_sid: \"application_sid\",\n      outgoing_application: %{\"key\" => \"value\"},\n      incoming_allow: true,\n      push_credential_sid: \"push_credential_sid\",\n      endpoint_id: \"endpoint_id\"\n    )","ref":"ExTwilio.JWT.AccessToken.VoiceGrant.html#module-examples"},{"type":"function","title":"ExTwilio.JWT.AccessToken.VoiceGrant.new/1","doc":"Create a new grant.","ref":"ExTwilio.JWT.AccessToken.VoiceGrant.html#new/1"},{"type":"type","title":"ExTwilio.JWT.AccessToken.VoiceGrant.t/0","doc":"","ref":"ExTwilio.JWT.AccessToken.VoiceGrant.html#t:t/0"},{"type":"protocol","title":"ExTwilio.JWT.Grant","doc":"A protocol for converting grants into JWT claims.","ref":"ExTwilio.JWT.Grant.html"},{"type":"function","title":"ExTwilio.JWT.Grant.attrs/1","doc":"The attributes of the claim.","ref":"ExTwilio.JWT.Grant.html#attrs/1"},{"type":"function","title":"Examples - ExTwilio.JWT.Grant.attrs/1","doc":"def attrs(grant) do\n      %{\"name\" => grant.name}\n    end","ref":"ExTwilio.JWT.Grant.html#attrs/1-examples"},{"type":"function","title":"ExTwilio.JWT.Grant.type/1","doc":"The type of claim this grant is.","ref":"ExTwilio.JWT.Grant.html#type/1"},{"type":"function","title":"Examples - ExTwilio.JWT.Grant.type/1","doc":"def type(_grant), do: \"chat\"","ref":"ExTwilio.JWT.Grant.html#type/1-examples"},{"type":"type","title":"ExTwilio.JWT.Grant.t/0","doc":"All the types that implement this protocol.","ref":"ExTwilio.JWT.Grant.html#t:t/0"},{"type":"module","title":"ExTwilio.Lookup","doc":"Represents the Lookup Api provided by Twilio\n\n- [Twilio docs](https://www.twilio.com/docs/lookup/api)","ref":"ExTwilio.Lookup.html"},{"type":"function","title":"ExTwilio.Lookup.retrieve/2","doc":"Retrieves information based on the inputed phone number. Supports Twilio's add-ons.","ref":"ExTwilio.Lookup.html#retrieve/2"},{"type":"function","title":"Examples - ExTwilio.Lookup.retrieve/2","doc":"{:ok, info} = ExTwilio.Lookup.retrieve(\"12345678910\", [Type: carrier])","ref":"ExTwilio.Lookup.html#retrieve/2-examples"},{"type":"module","title":"ExTwilio.Media","doc":"Represents an Media resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/sms/api/media-resource)","ref":"ExTwilio.Media.html"},{"type":"module","title":"Examples - ExTwilio.Media","doc":"Since Media belong to a Message in Twilio's API, you must pass a Message SID\nto each function in this module.\n\n    ExTwilio.Media.all(message: \"message_sid\")","ref":"ExTwilio.Media.html#module-examples"},{"type":"function","title":"ExTwilio.Media.all/1","doc":"","ref":"ExTwilio.Media.html#all/1"},{"type":"function","title":"ExTwilio.Media.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Media.html#children/0"},{"type":"function","title":"ExTwilio.Media.destroy/2","doc":"","ref":"ExTwilio.Media.html#destroy/2"},{"type":"function","title":"ExTwilio.Media.do_new/2","doc":"","ref":"ExTwilio.Media.html#do_new/2"},{"type":"function","title":"ExTwilio.Media.find/2","doc":"","ref":"ExTwilio.Media.html#find/2"},{"type":"function","title":"ExTwilio.Media.new/0","doc":"","ref":"ExTwilio.Media.html#new/0"},{"type":"function","title":"ExTwilio.Media.new/1","doc":"","ref":"ExTwilio.Media.html#new/1"},{"type":"function","title":"ExTwilio.Media.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Media.html#parents/0"},{"type":"function","title":"ExTwilio.Media.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Media.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Media.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Media.html#resource_name/0"},{"type":"function","title":"ExTwilio.Media.stream/1","doc":"","ref":"ExTwilio.Media.html#stream/1"},{"type":"module","title":"ExTwilio.Member","doc":"Represents an Member resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/chat/rest/member-resource)","ref":"ExTwilio.Member.html"},{"type":"module","title":"Examples - ExTwilio.Member","doc":"Since Members are members of a Queue in the Twilio API, you must pass a Queue\nSID into each function in this module.\n\n    ExTwilio.Member.all(queue: \"queue_sid\")","ref":"ExTwilio.Member.html#module-examples"},{"type":"function","title":"ExTwilio.Member.all/1","doc":"","ref":"ExTwilio.Member.html#all/1"},{"type":"function","title":"ExTwilio.Member.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Member.html#children/0"},{"type":"function","title":"ExTwilio.Member.do_new/2","doc":"","ref":"ExTwilio.Member.html#do_new/2"},{"type":"function","title":"ExTwilio.Member.find/2","doc":"","ref":"ExTwilio.Member.html#find/2"},{"type":"function","title":"ExTwilio.Member.new/0","doc":"","ref":"ExTwilio.Member.html#new/0"},{"type":"function","title":"ExTwilio.Member.new/1","doc":"","ref":"ExTwilio.Member.html#new/1"},{"type":"function","title":"ExTwilio.Member.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Member.html#parents/0"},{"type":"function","title":"ExTwilio.Member.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Member.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Member.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Member.html#resource_name/0"},{"type":"function","title":"ExTwilio.Member.stream/1","doc":"","ref":"ExTwilio.Member.html#stream/1"},{"type":"function","title":"ExTwilio.Member.update/3","doc":"","ref":"ExTwilio.Member.html#update/3"},{"type":"module","title":"ExTwilio.Message","doc":"Represents an Message resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/sms/api/message-resource)","ref":"ExTwilio.Message.html"},{"type":"module","title":"Examples - ExTwilio.Message","doc":"Here is an example of sending an SMS message:\n\n    {target_number, twilio_number_you_own, body} = {\"+12223334444\", \"+19223334444\", \"Hello World\"}\n\n    ExTwilio.Message.create(to: target_number, from: twilio_number_you_own, body: body)","ref":"ExTwilio.Message.html#module-examples"},{"type":"function","title":"ExTwilio.Message.all/1","doc":"","ref":"ExTwilio.Message.html#all/1"},{"type":"function","title":"ExTwilio.Message.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Message.html#children/0"},{"type":"function","title":"ExTwilio.Message.create/2","doc":"","ref":"ExTwilio.Message.html#create/2"},{"type":"function","title":"ExTwilio.Message.destroy/2","doc":"","ref":"ExTwilio.Message.html#destroy/2"},{"type":"function","title":"ExTwilio.Message.do_new/2","doc":"","ref":"ExTwilio.Message.html#do_new/2"},{"type":"function","title":"ExTwilio.Message.find/2","doc":"","ref":"ExTwilio.Message.html#find/2"},{"type":"function","title":"ExTwilio.Message.new/0","doc":"","ref":"ExTwilio.Message.html#new/0"},{"type":"function","title":"ExTwilio.Message.new/1","doc":"","ref":"ExTwilio.Message.html#new/1"},{"type":"function","title":"ExTwilio.Message.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Message.html#parents/0"},{"type":"function","title":"ExTwilio.Message.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Message.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Message.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Message.html#resource_name/0"},{"type":"function","title":"ExTwilio.Message.stream/1","doc":"","ref":"ExTwilio.Message.html#stream/1"},{"type":"function","title":"ExTwilio.Message.update/3","doc":"","ref":"ExTwilio.Message.html#update/3"},{"type":"module","title":"ExTwilio.Notification","doc":"Represents a Notification resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/notify/api/notification-resource)","ref":"ExTwilio.Notification.html"},{"type":"function","title":"ExTwilio.Notification.all/1","doc":"","ref":"ExTwilio.Notification.html#all/1"},{"type":"function","title":"ExTwilio.Notification.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Notification.html#children/0"},{"type":"function","title":"ExTwilio.Notification.destroy/2","doc":"","ref":"ExTwilio.Notification.html#destroy/2"},{"type":"function","title":"ExTwilio.Notification.do_new/2","doc":"","ref":"ExTwilio.Notification.html#do_new/2"},{"type":"function","title":"ExTwilio.Notification.find/2","doc":"","ref":"ExTwilio.Notification.html#find/2"},{"type":"function","title":"ExTwilio.Notification.new/0","doc":"","ref":"ExTwilio.Notification.html#new/0"},{"type":"function","title":"ExTwilio.Notification.new/1","doc":"","ref":"ExTwilio.Notification.html#new/1"},{"type":"function","title":"ExTwilio.Notification.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Notification.html#parents/0"},{"type":"function","title":"ExTwilio.Notification.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Notification.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Notification.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Notification.html#resource_name/0"},{"type":"function","title":"ExTwilio.Notification.stream/1","doc":"","ref":"ExTwilio.Notification.html#stream/1"},{"type":"module","title":"ExTwilio.Notify.Binding","doc":"Represents a Binding resource in the Twilio Notify.\n\n- [Twilio docs](https://www.twilio.com/docs/notify/api/bindings)\n\n- identity The Identity to which this Binding belongs to. Identity is defined\nby your application. Up to 20 Bindings can be created for the same Identity\nin a given Service.\n- binding_type The type of the Binding. This determines the transport technology to use. Allowed values: `apn`, `fcm`, `gcm`, `sms`, and `facebook-messenger`.\n- address The address specific to the channel. For APNS it is the device\ntoken. For FCM and GCM it is the registration token. For SMS it is a phone\nnumber in E.164 format. For Facebook Messenger it is the Messenger ID of the user or a phone number in E.164 format.\n- tag The list of tags associated with this Binding. Tags can be used to\nselect the Bindings to use when sending a notification. Maximum 20 tags are\nallowed.\n- notification_protocol_version The version of the protocol (data format)\nused to send the notification. This defaults to the value of\nDefaultXXXNotificationProtocolVersion in the `ExTwilio.Notify.Service`.\nThe current version is `\"3\"` for `apn`, `fcm`, and `gcm` type Bindings. The\nparameter is not applicable to `sms` and `facebook-messenger` type Bindings as the data format is fixed.\n- credential_sid The unique identifier (SID) of the\n`ExTwilio.Notify.Credential` resource to be used to send notifications to\nthis Binding. If present, this overrides the Credential specified in the\nService resource. Applicable only to `apn`, `fcm`, and `gcm` type Bindings.","ref":"ExTwilio.Notify.Binding.html"},{"type":"function","title":"ExTwilio.Notify.Binding.all/1","doc":"","ref":"ExTwilio.Notify.Binding.html#all/1"},{"type":"function","title":"ExTwilio.Notify.Binding.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Notify.Binding.html#children/0"},{"type":"function","title":"ExTwilio.Notify.Binding.create/2","doc":"","ref":"ExTwilio.Notify.Binding.html#create/2"},{"type":"function","title":"ExTwilio.Notify.Binding.destroy/2","doc":"","ref":"ExTwilio.Notify.Binding.html#destroy/2"},{"type":"function","title":"ExTwilio.Notify.Binding.do_new/2","doc":"","ref":"ExTwilio.Notify.Binding.html#do_new/2"},{"type":"function","title":"ExTwilio.Notify.Binding.find/2","doc":"","ref":"ExTwilio.Notify.Binding.html#find/2"},{"type":"function","title":"ExTwilio.Notify.Binding.new/0","doc":"","ref":"ExTwilio.Notify.Binding.html#new/0"},{"type":"function","title":"ExTwilio.Notify.Binding.new/1","doc":"","ref":"ExTwilio.Notify.Binding.html#new/1"},{"type":"function","title":"ExTwilio.Notify.Binding.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Notify.Binding.html#parents/0"},{"type":"function","title":"ExTwilio.Notify.Binding.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Notify.Binding.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Notify.Binding.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Notify.Binding.html#resource_name/0"},{"type":"function","title":"ExTwilio.Notify.Binding.stream/1","doc":"","ref":"ExTwilio.Notify.Binding.html#stream/1"},{"type":"function","title":"ExTwilio.Notify.Binding.update/3","doc":"","ref":"ExTwilio.Notify.Binding.html#update/3"},{"type":"module","title":"ExTwilio.Notify.Credential","doc":"Represents a Credential resource in the Twilio Notify.\n\n- [Twilio docs](https://www.twilio.com/docs/notify/api/credentials)\n\n- type Credential type, one of \"gcm\", \"fcm\", or \"apn\"\n- friendly_name Friendly name for stored credential\n- certificate [APN only] URL encoded representation of the certificate. Strip everything outside of the headers, e.g. `-----BEGIN\nCERTIFICATE-----MIIFnTCCBIWgAwIBAgIIAjy9H849+E8wDQYJKoZIhvcNAQEFBQAwgZYxCzAJBgNV.....A==-----END CERTIFICATE-----`\n- private_key [APN only] URL encoded representation of the private key. Strip everything outside of the headers, e.g. `-----BEGIN RSA PRIVATE\nKEY-----MIIEpQIBAAKCAQEAuyf/lNrH9ck8DmNyo3fGgvCI1l9s+cmBY3WIz+cUDqmxiieR\n.-----END RSA PRIVATE KEY-----`\n- sandbox [APN only] use this credential for sending to production or sandbox APNs (string `true` or `false`)\n- api_key [GCM only] This is the \"Server key\" of your project from\nFirebase console under Settings / Cloud messaging. Yes, you can use the\nserver key from the Firebase console for GCM.\n- secret [FCM only] This is the \"Server key\" of your project from Firebase console under Settings / Cloud messaging.","ref":"ExTwilio.Notify.Credential.html"},{"type":"function","title":"ExTwilio.Notify.Credential.all/1","doc":"","ref":"ExTwilio.Notify.Credential.html#all/1"},{"type":"function","title":"ExTwilio.Notify.Credential.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Notify.Credential.html#children/0"},{"type":"function","title":"ExTwilio.Notify.Credential.create/2","doc":"","ref":"ExTwilio.Notify.Credential.html#create/2"},{"type":"function","title":"ExTwilio.Notify.Credential.destroy/2","doc":"","ref":"ExTwilio.Notify.Credential.html#destroy/2"},{"type":"function","title":"ExTwilio.Notify.Credential.do_new/2","doc":"","ref":"ExTwilio.Notify.Credential.html#do_new/2"},{"type":"function","title":"ExTwilio.Notify.Credential.find/2","doc":"","ref":"ExTwilio.Notify.Credential.html#find/2"},{"type":"function","title":"ExTwilio.Notify.Credential.new/0","doc":"","ref":"ExTwilio.Notify.Credential.html#new/0"},{"type":"function","title":"ExTwilio.Notify.Credential.new/1","doc":"","ref":"ExTwilio.Notify.Credential.html#new/1"},{"type":"function","title":"ExTwilio.Notify.Credential.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Notify.Credential.html#parents/0"},{"type":"function","title":"ExTwilio.Notify.Credential.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Notify.Credential.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Notify.Credential.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Notify.Credential.html#resource_name/0"},{"type":"function","title":"ExTwilio.Notify.Credential.stream/1","doc":"","ref":"ExTwilio.Notify.Credential.html#stream/1"},{"type":"function","title":"ExTwilio.Notify.Credential.update/3","doc":"","ref":"ExTwilio.Notify.Credential.html#update/3"},{"type":"module","title":"ExTwilio.Notify.Notification","doc":"Represents a Notification resource in the Twilio Notify.\n\n- [Twilio docs](https://www.twilio.com/docs/notify/api/notifications)\n\n- body (optional for all except Alexa) Indicates the notification body text.\nTranslates to `data.twi_body` for FCM and GCM, `aps.alert.body` for  APNS,\n`Body` for SMS and Facebook Messenger and `request.message.data` for Alexa.\nFor SMS either this, `body`, or the `media_url` attribute of the `Sms`\nparameter is required.  For Facebook Messenger either this parameter or the\nbody attribute in the `FacebookMessenger` parameter is required.\n- priority Two priorities defined: `low` and `high` (default). `low`\noptimizes the client app's battery consumption, and notifications may be\ndelivered with unspecified delay. This is the same as Normal priority for FCM\nand GCM or priority 5 for APNS. `high` sends the notification immediately,\nand can wake up a sleeping device. This is the same as High priority for FCM\nand GCM or priority 10 for APNS.  This feature is not supported by SMS and\nFacebook Messenger and will be ignored for deliveries via those channels.\n- ttl This parameter specifies how long (in seconds) the notification is\nvalid. Delivery should be attempted if the device is offline. The maximum\ntime to live supported is 4 weeks. The value zero means that the notification\ndelivery is attempted immediately once but not stored for future delivery.\nThe default value is 4 weeks.  This feature is not supported by SMS and\nFacebook Messenger and will be ignored for deliveries via those channels.\n- title (optional for all except Alexa) Indicates the notification title.\nThis field is not visible on iOS phones and tablets but it is on Apple Watch\nand Android devices. Translates to `data.twi_title` for FCM and GCM,\n`aps.alert.title` for APNS and `displayInfo.content[0].title`,\n`displayInfo.content[].toast.primaryText` of `request.message` for Alexa. It\nis  not supported for SMS and Facebook Messenger and will be omitted from\ndeliveries via those channels.\n- sound Indicates a sound to be played. Translates to `data.twi_sound` for\nFCM and GCM and `aps.sound` for APNS.  This parameter is not supported by SMS\nand Facebook Messenger and is omitted from deliveries via those channels.\n- action Specifies the actions to be displayed for the notification.\nTranslates to `data.twi_action` for GCM and `aps.category` for APNS. This\nparameter is not supported by SMS and Facebook Messenger and is omitted from\ndeliveries via those channels.\n- data This parameter specifies the custom key-value pairs of the\nnotification's payload. Translates to `data` dictionary in FCM and GCM\npayload. FCM and GCM [reserves certain keys](https://firebase.google.com/docs/cloud-messaging/http-server-ref)\nthat cannot be used for those channels. For APNS, attributes of `Data` will be\ninserted into the APNS payload as custom properties outside of the `aps`\ndictionary. For Alexa they are added to `request.message.data`. For all\nchannels, the `twi_` prefix is reserved for Twilio for future use. Requests\nincluding custom data with keys starting with `twi_` will be rejected as 400\nBad request and no delivery will be attempted.  This parameter is not\nsupported by SMS and Facebook Messenger and is omitted from deliveries via\nthose channels.\n-apn APNS specific payload that overrides corresponding attributes in a\ngeneric payload for Bindings with the apn BindingType. This value is mapped\nto the Payload item, therefore the `aps` key has to be used to change standard\nattributes. Adds custom key-value pairs to the root of the dictionary. Refer\nto  [APNS documentation](https://developer.apple.com/library/content/documentation/NetworkingInternet/Conceptual/RemoteNotificationsPG/CommunicatingwithAPNs.html) for more\ndetails. The `twi_` key prefix for custom key-value pairs is reserved for\nTwilio for future use. Custom data with keys starting with `twi_` is not\nallowed.\n- gcm GCM specific payload that overrides corresponding attributes in generic\npayload for Bindings with gcm BindingType.  This value is mapped to the root\njson dictionary. Refer to [GCM documentation](https://developers.google.com/cloud-messaging/http-server-ref)\nfor more details.  Target parameters `to`, `registration_ids`, and\n`notification_key` are not allowed. The `twi_` key prefix for custom key-value\npairs is reserved for Twilio for future use. Custom data with keys starting\nwith `twi_` is not allowed. FCM and GCM\n[reserves certain keys](https://firebase.google.com/docs/cloud-messaging/http-server-ref)\n that cannot be used for those channels.\n- sms SMS specific payload that overrides corresponding attributes in generic\npayload for Bindings with sms BindingType.  Each attribute in this JSON\nobject is mapped to the corresponding form parameter of the Twilio\n [Message](https://www.twilio.com/docs/api/rest/sending-messages) resource.\n The following parameters of the Message resource are supported in snake case\n format: `body`, `media_urls`, `status_callback`, and `max_price`.  The\n `status_callback`  parameter overrides the corresponding parameter in the\n messaging service if  configured. The `media_urls` expects a JSON array.\n - facebook_messenger Messenger specific payload that overrides corresponding\n attributes in generic payload for Bindings with facebook-messenger\n BindingType.  This value is mapped to the root json dictionary of Facebook's\n [Send API  request](https://developers.facebook.com/docs/messenger-platform/send-api-reference).\n  Overriding the `recipient` parameter is not allowed.\n- fcm FCM specific payload that overrides corresponding attributes in generic\npayload for Bindings with fcm BindingType.  This value is mapped to the root\njson dictionary. Refer to [FCM documentation](https://firebase.google.com/docs/cloud-messaging/http-server-ref#downstream)\nfor more details.  Target parameters `to`, `registration_ids`, `condition`,\nand `notification_key` are not allowed. The `twi_` key prefix for custom\nkey-value pairs is reserved for Twilio for future use. Custom data with keys\nstarting with `twi_` is not allowed. Custom data with keys starting with\n`twi_` is not allowed. FCM and GCM\n[reserves certain keys](https://firebase.google.com/docs/cloud-messaging/http-server-ref)\nthat cannot be used for those channels.\n- segment The segment\n- alexa The alexa\n- to_binding The destination address in a JSON object (see attributes below).\nMultiple ToBinding parameters can be included but the total size of the\nrequest entity should not exceed 1MB. This is typically sufficient for\n10,000 phone numbers.\n- identity Delivery will be attempted only to Bindings with an Identity in\nthis list. Maximum 20 items allowed in this list.\n- tag Delivery will be attempted only to Bindings that have all of the Tags\nin this list. Maximum 5 items allowed in this list. The implicit tag \"all\" is\navailable to notify all Bindings in a Service instance. Similarly the\nimplicit tags \"apn\", \"fcm\", \"gcm\", \"sms\" and \"facebook-messenger\" are\navailable to notify all Bindings of the given type.","ref":"ExTwilio.Notify.Notification.html"},{"type":"function","title":"ExTwilio.Notify.Notification.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Notify.Notification.html#children/0"},{"type":"function","title":"ExTwilio.Notify.Notification.create/2","doc":"","ref":"ExTwilio.Notify.Notification.html#create/2"},{"type":"function","title":"ExTwilio.Notify.Notification.do_new/2","doc":"","ref":"ExTwilio.Notify.Notification.html#do_new/2"},{"type":"function","title":"ExTwilio.Notify.Notification.new/0","doc":"","ref":"ExTwilio.Notify.Notification.html#new/0"},{"type":"function","title":"ExTwilio.Notify.Notification.new/1","doc":"","ref":"ExTwilio.Notify.Notification.html#new/1"},{"type":"function","title":"ExTwilio.Notify.Notification.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Notify.Notification.html#parents/0"},{"type":"function","title":"ExTwilio.Notify.Notification.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Notify.Notification.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Notify.Notification.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Notify.Notification.html#resource_name/0"},{"type":"module","title":"ExTwilio.Notify.Service","doc":"Represents a Service resource in the Twilio Notify.\n\n- [Twilio docs](https://www.twilio.com/docs/notify/api/services)\n\n- friendly_name Human-readable name for this service instance\n- apn_credential_sid The SID of the `ExTwilio.Notify.Credential` to be used\nfor APN Bindings.\n- gcm_credential_sid The SID of the `ExTwilio.Notify.Credential` to be used for GCM Bindings.\n- messaging_service_sid The SID of the [Messaging Service]\n(https://www.twilio.com/docs/api/rest/sending-messages#messaging-services) to\nbe used for SMS Bindings. In order to send SMS notifications this parameter\nhas to be set.\n- facebook_messenger_page_id The Page ID to be used to send for Facebook\nMessenger Bindings. It has to match the Page ID you configured when you\n[enabled Facebook Messaging](https://www.twilio.com/console/sms/settings) on your account.\n- default_apn_notification_protocol_version The version of the protocol to be\nused for sending APNS notifications. Can be overriden on a Binding by Binding basis when creating a `ExTwilio.Notify.Bindings` resource.\n- default_gcm_notification_protocol_version The version of the protocol to be\nused for sending GCM notifications. Can be overriden on a Binding by Binding\nbasis when creating a `ExTwilio.Notify.Bindings` resource.\n- fcm_credential_sid The SID of the `ExTwilio.Notify.Credential` to be used\nfor FCM Bindings.\n- default_fcm_notification_protocol_version The version of the protocol to be\nused for sending FCM notifications. Can be overriden on a Binding by Binding\nbasis when creating a `ExTwilio.Notify.Credential` resource.\n- log_enabled The log_enabled\n- alexa_skill_id The alexa_skill_id\n- default_alexa_notification_protocol_version The default_alexa_notification_protocol_version","ref":"ExTwilio.Notify.Service.html"},{"type":"function","title":"ExTwilio.Notify.Service.all/1","doc":"","ref":"ExTwilio.Notify.Service.html#all/1"},{"type":"function","title":"ExTwilio.Notify.Service.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Notify.Service.html#children/0"},{"type":"function","title":"ExTwilio.Notify.Service.create/2","doc":"","ref":"ExTwilio.Notify.Service.html#create/2"},{"type":"function","title":"ExTwilio.Notify.Service.destroy/2","doc":"","ref":"ExTwilio.Notify.Service.html#destroy/2"},{"type":"function","title":"ExTwilio.Notify.Service.do_new/2","doc":"","ref":"ExTwilio.Notify.Service.html#do_new/2"},{"type":"function","title":"ExTwilio.Notify.Service.find/2","doc":"","ref":"ExTwilio.Notify.Service.html#find/2"},{"type":"function","title":"ExTwilio.Notify.Service.new/0","doc":"","ref":"ExTwilio.Notify.Service.html#new/0"},{"type":"function","title":"ExTwilio.Notify.Service.new/1","doc":"","ref":"ExTwilio.Notify.Service.html#new/1"},{"type":"function","title":"ExTwilio.Notify.Service.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Notify.Service.html#parents/0"},{"type":"function","title":"ExTwilio.Notify.Service.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Notify.Service.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Notify.Service.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Notify.Service.html#resource_name/0"},{"type":"function","title":"ExTwilio.Notify.Service.stream/1","doc":"","ref":"ExTwilio.Notify.Service.html#stream/1"},{"type":"function","title":"ExTwilio.Notify.Service.update/3","doc":"","ref":"ExTwilio.Notify.Service.html#update/3"},{"type":"module","title":"ExTwilio.OutgoingCallerId","doc":"Represents an OutgoingCallerId resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/voice/api/outgoing-caller-ids)","ref":"ExTwilio.OutgoingCallerId.html"},{"type":"function","title":"ExTwilio.OutgoingCallerId.all/1","doc":"","ref":"ExTwilio.OutgoingCallerId.html#all/1"},{"type":"function","title":"ExTwilio.OutgoingCallerId.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.OutgoingCallerId.html#children/0"},{"type":"function","title":"ExTwilio.OutgoingCallerId.create/2","doc":"","ref":"ExTwilio.OutgoingCallerId.html#create/2"},{"type":"function","title":"ExTwilio.OutgoingCallerId.destroy/2","doc":"","ref":"ExTwilio.OutgoingCallerId.html#destroy/2"},{"type":"function","title":"ExTwilio.OutgoingCallerId.do_new/2","doc":"","ref":"ExTwilio.OutgoingCallerId.html#do_new/2"},{"type":"function","title":"ExTwilio.OutgoingCallerId.find/2","doc":"","ref":"ExTwilio.OutgoingCallerId.html#find/2"},{"type":"function","title":"ExTwilio.OutgoingCallerId.new/0","doc":"","ref":"ExTwilio.OutgoingCallerId.html#new/0"},{"type":"function","title":"ExTwilio.OutgoingCallerId.new/1","doc":"","ref":"ExTwilio.OutgoingCallerId.html#new/1"},{"type":"function","title":"ExTwilio.OutgoingCallerId.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.OutgoingCallerId.html#parents/0"},{"type":"function","title":"ExTwilio.OutgoingCallerId.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.OutgoingCallerId.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.OutgoingCallerId.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.OutgoingCallerId.html#resource_name/0"},{"type":"function","title":"ExTwilio.OutgoingCallerId.stream/1","doc":"","ref":"ExTwilio.OutgoingCallerId.html#stream/1"},{"type":"function","title":"ExTwilio.OutgoingCallerId.update/3","doc":"","ref":"ExTwilio.OutgoingCallerId.html#update/3"},{"type":"module","title":"ExTwilio.Parent","doc":"This module provides structure for the specification of parents to a resource.\n\nIt contains a `module` which should be the full module name of the parent\nresource, as well as a key which represents the key that will be matched\nagainst the options list to find the `sid` of the parent resource and place it\ninto the url correctly.","ref":"ExTwilio.Parent.html"},{"type":"module","title":"ExTwilio.Parser","doc":"A JSON parser tuned specifically for Twilio API responses. Based on Poison's\nexcellent JSON decoder.","ref":"ExTwilio.Parser.html"},{"type":"function","title":"ExTwilio.Parser.parse/2","doc":"Parse a response expected to contain a single resource. If you pass in a\nmodule as the first argument, the JSON will be parsed into that module's\n`__struct__`.","ref":"ExTwilio.Parser.html#parse/2"},{"type":"function","title":"Examples - ExTwilio.Parser.parse/2","doc":"Given you have a module named `Resource`, defined like this:\n\n    defmodule Resource do\n      defstruct sid: nil\n    end\n\nYou can parse JSON into that module's struct like so:\n\n    iex> response = %{body: \"{ \\\"sid\\\": \\\"AD34123\\\" }\", status_code: 200}\n    ...> ExTwilio.Parser.parse(response, Resource)\n    {:ok, %Resource{sid: \"AD34123\"}}\n\nYou can also parse into a regular map if you want.\n\n    iex> response = %{body: \"{ \\\"sid\\\": \\\"AD34123\\\" }\", status_code: 200}\n    ...> ExTwilio.Parser.parse(response, %{})\n    {:ok, %{\"sid\" => \"AD34123\"}}","ref":"ExTwilio.Parser.html#parse/2-examples"},{"type":"function","title":"ExTwilio.Parser.parse_list/3","doc":"Parse a response expected to contain multiple resources. If you pass in a\nmodule as the first argument, the JSON will be parsed into that module's\n`__struct__`.","ref":"ExTwilio.Parser.html#parse_list/3"},{"type":"function","title":"Examples - ExTwilio.Parser.parse_list/3","doc":"Given you have a module named `Resource`, defined like this:\n\n    defmodule Resource do\n      defstruct sid: nil\n    end\n\nAnd the JSON you are parsing looks like this:\n\n    {\n      \"resources\": [{\n        \"sid\": \"first\"\n      }, {\n        \"sid\": \"second\"\n      }],\n      \"next_page\": 10\n    }\n\nYou can parse the the JSON like this:\n\n    ExTwilio.Parser.parse_list(json, Resource, \"resources\")\n    {:ok, [%Resource{sid: \"first\"}, %Resource{sid: \"second\"}], %{\"next_page\" => 10}}","ref":"ExTwilio.Parser.html#parse_list/3-examples"},{"type":"type","title":"ExTwilio.Parser.error/0","doc":"","ref":"ExTwilio.Parser.html#t:error/0"},{"type":"type","title":"ExTwilio.Parser.http_status_code/0","doc":"","ref":"ExTwilio.Parser.html#t:http_status_code/0"},{"type":"type","title":"ExTwilio.Parser.key/0","doc":"","ref":"ExTwilio.Parser.html#t:key/0"},{"type":"type","title":"ExTwilio.Parser.metadata/0","doc":"","ref":"ExTwilio.Parser.html#t:metadata/0"},{"type":"type","title":"ExTwilio.Parser.parsed_list_response/0","doc":"","ref":"ExTwilio.Parser.html#t:parsed_list_response/0"},{"type":"type","title":"ExTwilio.Parser.parsed_response/0","doc":"","ref":"ExTwilio.Parser.html#t:parsed_response/0"},{"type":"type","title":"ExTwilio.Parser.success/0","doc":"","ref":"ExTwilio.Parser.html#t:success/0"},{"type":"type","title":"ExTwilio.Parser.success_delete/0","doc":"","ref":"ExTwilio.Parser.html#t:success_delete/0"},{"type":"type","title":"ExTwilio.Parser.success_list/0","doc":"","ref":"ExTwilio.Parser.html#t:success_list/0"},{"type":"module","title":"ExTwilio.Participant","doc":"Represents a Participant resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/voice/api/conference-participant-resource)","ref":"ExTwilio.Participant.html"},{"type":"module","title":"Examples - ExTwilio.Participant","doc":"Since Participants belong to Conferences in the Twilio API, you must pass a\nconference to each function in this module. For example:\n\n    ExTwilio.Participant.all(conference: \"conference_sid\")","ref":"ExTwilio.Participant.html#module-examples"},{"type":"function","title":"ExTwilio.Participant.all/1","doc":"","ref":"ExTwilio.Participant.html#all/1"},{"type":"function","title":"ExTwilio.Participant.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Participant.html#children/0"},{"type":"function","title":"ExTwilio.Participant.create/2","doc":"","ref":"ExTwilio.Participant.html#create/2"},{"type":"function","title":"ExTwilio.Participant.destroy/2","doc":"","ref":"ExTwilio.Participant.html#destroy/2"},{"type":"function","title":"ExTwilio.Participant.do_new/2","doc":"","ref":"ExTwilio.Participant.html#do_new/2"},{"type":"function","title":"ExTwilio.Participant.find/2","doc":"","ref":"ExTwilio.Participant.html#find/2"},{"type":"function","title":"ExTwilio.Participant.new/0","doc":"","ref":"ExTwilio.Participant.html#new/0"},{"type":"function","title":"ExTwilio.Participant.new/1","doc":"","ref":"ExTwilio.Participant.html#new/1"},{"type":"function","title":"ExTwilio.Participant.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Participant.html#parents/0"},{"type":"function","title":"ExTwilio.Participant.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Participant.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Participant.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Participant.html#resource_name/0"},{"type":"function","title":"ExTwilio.Participant.stream/1","doc":"","ref":"ExTwilio.Participant.html#stream/1"},{"type":"function","title":"ExTwilio.Participant.update/3","doc":"","ref":"ExTwilio.Participant.html#update/3"},{"type":"module","title":"ExTwilio.ProgrammableChat.Channel","doc":"Represents a Channel resource in the Twilio Programmable Chat API.\n\n- [Twilio docs](https://www.twilio.com/docs/api/chat/rest/channels)","ref":"ExTwilio.ProgrammableChat.Channel.html"},{"type":"function","title":"ExTwilio.ProgrammableChat.Channel.all/1","doc":"","ref":"ExTwilio.ProgrammableChat.Channel.html#all/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Channel.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.ProgrammableChat.Channel.html#children/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Channel.create/2","doc":"","ref":"ExTwilio.ProgrammableChat.Channel.html#create/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Channel.destroy/2","doc":"","ref":"ExTwilio.ProgrammableChat.Channel.html#destroy/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Channel.do_new/2","doc":"","ref":"ExTwilio.ProgrammableChat.Channel.html#do_new/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Channel.find/2","doc":"","ref":"ExTwilio.ProgrammableChat.Channel.html#find/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Channel.new/0","doc":"","ref":"ExTwilio.ProgrammableChat.Channel.html#new/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Channel.new/1","doc":"","ref":"ExTwilio.ProgrammableChat.Channel.html#new/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Channel.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.ProgrammableChat.Channel.html#parents/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Channel.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ProgrammableChat.Channel.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Channel.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ProgrammableChat.Channel.html#resource_name/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Channel.stream/1","doc":"","ref":"ExTwilio.ProgrammableChat.Channel.html#stream/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Channel.update/3","doc":"","ref":"ExTwilio.ProgrammableChat.Channel.html#update/3"},{"type":"module","title":"ExTwilio.ProgrammableChat.Credential","doc":"Represents a Credential resource in the Twilio Programmable Chat API.\n\n- [Twilio docs](https://www.twilio.com/docs/api/chat/rest/credentials)","ref":"ExTwilio.ProgrammableChat.Credential.html"},{"type":"function","title":"ExTwilio.ProgrammableChat.Credential.all/1","doc":"","ref":"ExTwilio.ProgrammableChat.Credential.html#all/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Credential.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.ProgrammableChat.Credential.html#children/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Credential.create/2","doc":"","ref":"ExTwilio.ProgrammableChat.Credential.html#create/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Credential.destroy/2","doc":"","ref":"ExTwilio.ProgrammableChat.Credential.html#destroy/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Credential.do_new/2","doc":"","ref":"ExTwilio.ProgrammableChat.Credential.html#do_new/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Credential.find/2","doc":"","ref":"ExTwilio.ProgrammableChat.Credential.html#find/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Credential.new/0","doc":"","ref":"ExTwilio.ProgrammableChat.Credential.html#new/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Credential.new/1","doc":"","ref":"ExTwilio.ProgrammableChat.Credential.html#new/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Credential.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.ProgrammableChat.Credential.html#parents/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Credential.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ProgrammableChat.Credential.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Credential.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ProgrammableChat.Credential.html#resource_name/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Credential.stream/1","doc":"","ref":"ExTwilio.ProgrammableChat.Credential.html#stream/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Credential.update/3","doc":"","ref":"ExTwilio.ProgrammableChat.Credential.html#update/3"},{"type":"module","title":"ExTwilio.ProgrammableChat.Member","doc":"Represents a Member resource in the Twilio Programmable Chat API.\n\n- [Twilio docs](https://www.twilio.com/docs/api/chat/rest/members)","ref":"ExTwilio.ProgrammableChat.Member.html"},{"type":"function","title":"ExTwilio.ProgrammableChat.Member.all/1","doc":"","ref":"ExTwilio.ProgrammableChat.Member.html#all/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Member.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.ProgrammableChat.Member.html#children/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Member.create/2","doc":"","ref":"ExTwilio.ProgrammableChat.Member.html#create/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Member.destroy/2","doc":"","ref":"ExTwilio.ProgrammableChat.Member.html#destroy/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Member.do_new/2","doc":"","ref":"ExTwilio.ProgrammableChat.Member.html#do_new/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Member.find/2","doc":"","ref":"ExTwilio.ProgrammableChat.Member.html#find/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Member.new/0","doc":"","ref":"ExTwilio.ProgrammableChat.Member.html#new/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Member.new/1","doc":"","ref":"ExTwilio.ProgrammableChat.Member.html#new/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Member.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.ProgrammableChat.Member.html#parents/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Member.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ProgrammableChat.Member.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Member.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ProgrammableChat.Member.html#resource_name/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Member.stream/1","doc":"","ref":"ExTwilio.ProgrammableChat.Member.html#stream/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Member.update/3","doc":"","ref":"ExTwilio.ProgrammableChat.Member.html#update/3"},{"type":"module","title":"ExTwilio.ProgrammableChat.Message","doc":"Represents a Message resource in the Twilio Programmable Chat API.\n\n- [Twilio docs](https://www.twilio.com/docs/api/chat/rest/messages)","ref":"ExTwilio.ProgrammableChat.Message.html"},{"type":"function","title":"ExTwilio.ProgrammableChat.Message.all/1","doc":"","ref":"ExTwilio.ProgrammableChat.Message.html#all/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Message.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.ProgrammableChat.Message.html#children/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Message.create/2","doc":"","ref":"ExTwilio.ProgrammableChat.Message.html#create/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Message.destroy/2","doc":"","ref":"ExTwilio.ProgrammableChat.Message.html#destroy/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Message.do_new/2","doc":"","ref":"ExTwilio.ProgrammableChat.Message.html#do_new/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Message.find/2","doc":"","ref":"ExTwilio.ProgrammableChat.Message.html#find/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Message.new/0","doc":"","ref":"ExTwilio.ProgrammableChat.Message.html#new/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Message.new/1","doc":"","ref":"ExTwilio.ProgrammableChat.Message.html#new/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Message.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.ProgrammableChat.Message.html#parents/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Message.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ProgrammableChat.Message.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Message.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ProgrammableChat.Message.html#resource_name/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Message.stream/1","doc":"","ref":"ExTwilio.ProgrammableChat.Message.html#stream/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Message.update/3","doc":"","ref":"ExTwilio.ProgrammableChat.Message.html#update/3"},{"type":"module","title":"ExTwilio.ProgrammableChat.Role","doc":"Represents a Message resource in the Twilio Programmable Chat API.\n\n- [Twilio docs](https://www.twilio.com/docs/api/chat/rest/roles)","ref":"ExTwilio.ProgrammableChat.Role.html"},{"type":"function","title":"ExTwilio.ProgrammableChat.Role.all/1","doc":"","ref":"ExTwilio.ProgrammableChat.Role.html#all/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Role.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.ProgrammableChat.Role.html#children/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Role.create/2","doc":"","ref":"ExTwilio.ProgrammableChat.Role.html#create/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Role.destroy/2","doc":"","ref":"ExTwilio.ProgrammableChat.Role.html#destroy/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Role.do_new/2","doc":"","ref":"ExTwilio.ProgrammableChat.Role.html#do_new/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Role.find/2","doc":"","ref":"ExTwilio.ProgrammableChat.Role.html#find/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Role.new/0","doc":"","ref":"ExTwilio.ProgrammableChat.Role.html#new/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Role.new/1","doc":"","ref":"ExTwilio.ProgrammableChat.Role.html#new/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Role.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.ProgrammableChat.Role.html#parents/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Role.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ProgrammableChat.Role.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Role.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ProgrammableChat.Role.html#resource_name/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Role.stream/1","doc":"","ref":"ExTwilio.ProgrammableChat.Role.html#stream/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Role.update/3","doc":"","ref":"ExTwilio.ProgrammableChat.Role.html#update/3"},{"type":"module","title":"ExTwilio.ProgrammableChat.Service","doc":"Represents a Service resource in the Twilio Programmable Chat API.\n\n- [Twilio docs](https://www.twilio.com/docs/api/chat/rest/services)","ref":"ExTwilio.ProgrammableChat.Service.html"},{"type":"function","title":"ExTwilio.ProgrammableChat.Service.all/1","doc":"","ref":"ExTwilio.ProgrammableChat.Service.html#all/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Service.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.ProgrammableChat.Service.html#children/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Service.create/2","doc":"","ref":"ExTwilio.ProgrammableChat.Service.html#create/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Service.destroy/2","doc":"","ref":"ExTwilio.ProgrammableChat.Service.html#destroy/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Service.do_new/2","doc":"","ref":"ExTwilio.ProgrammableChat.Service.html#do_new/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Service.find/2","doc":"","ref":"ExTwilio.ProgrammableChat.Service.html#find/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.Service.new/0","doc":"","ref":"ExTwilio.ProgrammableChat.Service.html#new/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Service.new/1","doc":"","ref":"ExTwilio.ProgrammableChat.Service.html#new/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Service.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.ProgrammableChat.Service.html#parents/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Service.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ProgrammableChat.Service.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Service.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ProgrammableChat.Service.html#resource_name/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.Service.stream/1","doc":"","ref":"ExTwilio.ProgrammableChat.Service.html#stream/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.Service.update/3","doc":"","ref":"ExTwilio.ProgrammableChat.Service.html#update/3"},{"type":"module","title":"ExTwilio.ProgrammableChat.User","doc":"Represents a User resource in the Twilio Programmable Chat API.\n\n- [Twilio docs](https://www.twilio.com/docs/api/chat/rest/users)","ref":"ExTwilio.ProgrammableChat.User.html"},{"type":"function","title":"ExTwilio.ProgrammableChat.User.all/1","doc":"","ref":"ExTwilio.ProgrammableChat.User.html#all/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.User.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.ProgrammableChat.User.html#children/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.User.create/2","doc":"","ref":"ExTwilio.ProgrammableChat.User.html#create/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.User.destroy/2","doc":"","ref":"ExTwilio.ProgrammableChat.User.html#destroy/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.User.do_new/2","doc":"","ref":"ExTwilio.ProgrammableChat.User.html#do_new/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.User.find/2","doc":"","ref":"ExTwilio.ProgrammableChat.User.html#find/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.User.new/0","doc":"","ref":"ExTwilio.ProgrammableChat.User.html#new/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.User.new/1","doc":"","ref":"ExTwilio.ProgrammableChat.User.html#new/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.User.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.ProgrammableChat.User.html#parents/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.User.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ProgrammableChat.User.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.User.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ProgrammableChat.User.html#resource_name/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.User.stream/1","doc":"","ref":"ExTwilio.ProgrammableChat.User.html#stream/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.User.update/3","doc":"","ref":"ExTwilio.ProgrammableChat.User.html#update/3"},{"type":"module","title":"ExTwilio.ProgrammableChat.UserChannel","doc":"Represents a User Channel resource in the Twilio Programmable Chat API.\n\n- [Twilio docs](https://www.twilio.com/docs/api/chat/rest/user-channels)","ref":"ExTwilio.ProgrammableChat.UserChannel.html"},{"type":"function","title":"ExTwilio.ProgrammableChat.UserChannel.all/1","doc":"","ref":"ExTwilio.ProgrammableChat.UserChannel.html#all/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.UserChannel.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.ProgrammableChat.UserChannel.html#children/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.UserChannel.do_new/2","doc":"","ref":"ExTwilio.ProgrammableChat.UserChannel.html#do_new/2"},{"type":"function","title":"ExTwilio.ProgrammableChat.UserChannel.new/0","doc":"","ref":"ExTwilio.ProgrammableChat.UserChannel.html#new/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.UserChannel.new/1","doc":"","ref":"ExTwilio.ProgrammableChat.UserChannel.html#new/1"},{"type":"function","title":"ExTwilio.ProgrammableChat.UserChannel.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.ProgrammableChat.UserChannel.html#parents/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.UserChannel.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ProgrammableChat.UserChannel.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.UserChannel.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ProgrammableChat.UserChannel.html#resource_name/0"},{"type":"function","title":"ExTwilio.ProgrammableChat.UserChannel.stream/1","doc":"","ref":"ExTwilio.ProgrammableChat.UserChannel.html#stream/1"},{"type":"module","title":"ExTwilio.Queue","doc":"Represents a Queue resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/voice/api/queue-resource)","ref":"ExTwilio.Queue.html"},{"type":"function","title":"ExTwilio.Queue.all/1","doc":"","ref":"ExTwilio.Queue.html#all/1"},{"type":"function","title":"ExTwilio.Queue.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Queue.html#children/0"},{"type":"function","title":"ExTwilio.Queue.create/2","doc":"","ref":"ExTwilio.Queue.html#create/2"},{"type":"function","title":"ExTwilio.Queue.destroy/2","doc":"","ref":"ExTwilio.Queue.html#destroy/2"},{"type":"function","title":"ExTwilio.Queue.do_new/2","doc":"","ref":"ExTwilio.Queue.html#do_new/2"},{"type":"function","title":"ExTwilio.Queue.find/2","doc":"","ref":"ExTwilio.Queue.html#find/2"},{"type":"function","title":"ExTwilio.Queue.new/0","doc":"","ref":"ExTwilio.Queue.html#new/0"},{"type":"function","title":"ExTwilio.Queue.new/1","doc":"","ref":"ExTwilio.Queue.html#new/1"},{"type":"function","title":"ExTwilio.Queue.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Queue.html#parents/0"},{"type":"function","title":"ExTwilio.Queue.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Queue.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Queue.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Queue.html#resource_name/0"},{"type":"function","title":"ExTwilio.Queue.stream/1","doc":"","ref":"ExTwilio.Queue.html#stream/1"},{"type":"function","title":"ExTwilio.Queue.update/3","doc":"","ref":"ExTwilio.Queue.html#update/3"},{"type":"module","title":"ExTwilio.Recording","doc":"Represents a Recording resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/voice/api/recording)","ref":"ExTwilio.Recording.html"},{"type":"function","title":"ExTwilio.Recording.all/1","doc":"","ref":"ExTwilio.Recording.html#all/1"},{"type":"function","title":"ExTwilio.Recording.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Recording.html#children/0"},{"type":"function","title":"ExTwilio.Recording.destroy/2","doc":"","ref":"ExTwilio.Recording.html#destroy/2"},{"type":"function","title":"ExTwilio.Recording.do_new/2","doc":"","ref":"ExTwilio.Recording.html#do_new/2"},{"type":"function","title":"ExTwilio.Recording.find/2","doc":"","ref":"ExTwilio.Recording.html#find/2"},{"type":"function","title":"ExTwilio.Recording.new/0","doc":"","ref":"ExTwilio.Recording.html#new/0"},{"type":"function","title":"ExTwilio.Recording.new/1","doc":"","ref":"ExTwilio.Recording.html#new/1"},{"type":"function","title":"ExTwilio.Recording.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Recording.html#parents/0"},{"type":"function","title":"ExTwilio.Recording.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Recording.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Recording.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Recording.html#resource_name/0"},{"type":"function","title":"ExTwilio.Recording.stream/1","doc":"","ref":"ExTwilio.Recording.html#stream/1"},{"type":"module","title":"ExTwilio.RequestValidator","doc":"Validates the authenticity of a Twilio request.\n\n- [Twilio docs](https://www.twilio.com/docs/usage/security)","ref":"ExTwilio.RequestValidator.html"},{"type":"function","title":"ExTwilio.RequestValidator.valid?/3","doc":"","ref":"ExTwilio.RequestValidator.html#valid?/3"},{"type":"function","title":"ExTwilio.RequestValidator.valid?/4","doc":"","ref":"ExTwilio.RequestValidator.html#valid?/4"},{"type":"module","title":"ExTwilio.Resource","doc":"Mixin to include `ExTwilio.Api` module functionality in a module with slightly\nprettier syntax.\n\nUnder the hood, it delegates all the work to other `ExTwilio` modules,\nprimarily `ExTwilio.Api`.","ref":"ExTwilio.Resource.html"},{"type":"module","title":"Examples - ExTwilio.Resource","doc":"Define a module, and `use ExTwilio.Resource`.\n\n    defmodule ExTwilio.Call do\n      use ExTwilio.Resource, import: [:stream, :all]\n\n      defstruct sid: nil, ...\n    end\n\nThe `import` option specifies which methods you want to be able to use.","ref":"ExTwilio.Resource.html#module-examples"},{"type":"module","title":"ExTwilio.ResultStream","doc":"Generate a stream of results for a given Twilio API URL. Pages are lazily\nloaded on demand.","ref":"ExTwilio.ResultStream.html"},{"type":"module","title":"Examples - ExTwilio.ResultStream","doc":"ExTwilio.ResultStream.new(ExTwilio.Call)\n    |> Stream.map(fn call -> call.sid end)\n    |> Enum.take(5)\n\n    # => [%ExTwilio.Call{ ... }, %ExTwilio.Call{ ... }, ...]","ref":"ExTwilio.ResultStream.html#module-examples"},{"type":"function","title":"ExTwilio.ResultStream.new/2","doc":"Create a new Stream.","ref":"ExTwilio.ResultStream.html#new/2"},{"type":"function","title":"Parameters - ExTwilio.ResultStream.new/2","doc":"- `module`: The name of the module to create a Stream of results for.","ref":"ExTwilio.ResultStream.html#new/2-parameters"},{"type":"function","title":"Examples - ExTwilio.ResultStream.new/2","doc":"ExTwilio.ResultStream.new(ExTwilio.Call)","ref":"ExTwilio.ResultStream.html#new/2-examples"},{"type":"type","title":"ExTwilio.ResultStream.url/0","doc":"","ref":"ExTwilio.ResultStream.html#t:url/0"},{"type":"module","title":"ExTwilio.ShortCode","doc":"Represents a ShortCode resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/sms/api/short-code)","ref":"ExTwilio.ShortCode.html"},{"type":"function","title":"ExTwilio.ShortCode.all/1","doc":"","ref":"ExTwilio.ShortCode.html#all/1"},{"type":"function","title":"ExTwilio.ShortCode.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.ShortCode.html#children/0"},{"type":"function","title":"ExTwilio.ShortCode.do_new/2","doc":"","ref":"ExTwilio.ShortCode.html#do_new/2"},{"type":"function","title":"ExTwilio.ShortCode.find/2","doc":"","ref":"ExTwilio.ShortCode.html#find/2"},{"type":"function","title":"ExTwilio.ShortCode.new/0","doc":"","ref":"ExTwilio.ShortCode.html#new/0"},{"type":"function","title":"ExTwilio.ShortCode.new/1","doc":"","ref":"ExTwilio.ShortCode.html#new/1"},{"type":"function","title":"ExTwilio.ShortCode.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.ShortCode.html#parents/0"},{"type":"function","title":"ExTwilio.ShortCode.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ShortCode.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.ShortCode.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.ShortCode.html#resource_name/0"},{"type":"function","title":"ExTwilio.ShortCode.stream/1","doc":"","ref":"ExTwilio.ShortCode.html#stream/1"},{"type":"function","title":"ExTwilio.ShortCode.update/3","doc":"","ref":"ExTwilio.ShortCode.html#update/3"},{"type":"module","title":"ExTwilio.SipCredential","doc":"Represents an SIP Credential in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/voice/sip/api/sip-credential-resource)","ref":"ExTwilio.SipCredential.html"},{"type":"function","title":"ExTwilio.SipCredential.all/1","doc":"","ref":"ExTwilio.SipCredential.html#all/1"},{"type":"function","title":"ExTwilio.SipCredential.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.SipCredential.html#children/0"},{"type":"function","title":"ExTwilio.SipCredential.create/2","doc":"","ref":"ExTwilio.SipCredential.html#create/2"},{"type":"function","title":"ExTwilio.SipCredential.destroy/2","doc":"","ref":"ExTwilio.SipCredential.html#destroy/2"},{"type":"function","title":"ExTwilio.SipCredential.do_new/2","doc":"","ref":"ExTwilio.SipCredential.html#do_new/2"},{"type":"function","title":"ExTwilio.SipCredential.find/2","doc":"","ref":"ExTwilio.SipCredential.html#find/2"},{"type":"function","title":"ExTwilio.SipCredential.new/0","doc":"","ref":"ExTwilio.SipCredential.html#new/0"},{"type":"function","title":"ExTwilio.SipCredential.new/1","doc":"","ref":"ExTwilio.SipCredential.html#new/1"},{"type":"function","title":"ExTwilio.SipCredential.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.SipCredential.html#parents/0"},{"type":"function","title":"ExTwilio.SipCredential.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.SipCredential.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.SipCredential.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.SipCredential.html#resource_name/0"},{"type":"function","title":"ExTwilio.SipCredential.stream/1","doc":"","ref":"ExTwilio.SipCredential.html#stream/1"},{"type":"function","title":"ExTwilio.SipCredential.update/3","doc":"","ref":"ExTwilio.SipCredential.html#update/3"},{"type":"module","title":"ExTwilio.SipCredentialList","doc":"Represents an SIP CredentialList in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/voice/sip/api/sip-credentiallist-resource)","ref":"ExTwilio.SipCredentialList.html"},{"type":"function","title":"ExTwilio.SipCredentialList.all/1","doc":"","ref":"ExTwilio.SipCredentialList.html#all/1"},{"type":"function","title":"ExTwilio.SipCredentialList.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.SipCredentialList.html#children/0"},{"type":"function","title":"ExTwilio.SipCredentialList.create/2","doc":"","ref":"ExTwilio.SipCredentialList.html#create/2"},{"type":"function","title":"ExTwilio.SipCredentialList.destroy/2","doc":"","ref":"ExTwilio.SipCredentialList.html#destroy/2"},{"type":"function","title":"ExTwilio.SipCredentialList.do_new/2","doc":"","ref":"ExTwilio.SipCredentialList.html#do_new/2"},{"type":"function","title":"ExTwilio.SipCredentialList.find/2","doc":"","ref":"ExTwilio.SipCredentialList.html#find/2"},{"type":"function","title":"ExTwilio.SipCredentialList.new/0","doc":"","ref":"ExTwilio.SipCredentialList.html#new/0"},{"type":"function","title":"ExTwilio.SipCredentialList.new/1","doc":"","ref":"ExTwilio.SipCredentialList.html#new/1"},{"type":"function","title":"ExTwilio.SipCredentialList.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.SipCredentialList.html#parents/0"},{"type":"function","title":"ExTwilio.SipCredentialList.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.SipCredentialList.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.SipCredentialList.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.SipCredentialList.html#resource_name/0"},{"type":"function","title":"ExTwilio.SipCredentialList.stream/1","doc":"","ref":"ExTwilio.SipCredentialList.html#stream/1"},{"type":"function","title":"ExTwilio.SipCredentialList.update/3","doc":"","ref":"ExTwilio.SipCredentialList.html#update/3"},{"type":"module","title":"ExTwilio.SipDomain","doc":"Represents an SIP Domain resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/voice/sip/api/sip-domain-resource)","ref":"ExTwilio.SipDomain.html"},{"type":"function","title":"ExTwilio.SipDomain.all/1","doc":"","ref":"ExTwilio.SipDomain.html#all/1"},{"type":"function","title":"ExTwilio.SipDomain.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.SipDomain.html#children/0"},{"type":"function","title":"ExTwilio.SipDomain.create/2","doc":"","ref":"ExTwilio.SipDomain.html#create/2"},{"type":"function","title":"ExTwilio.SipDomain.destroy/2","doc":"","ref":"ExTwilio.SipDomain.html#destroy/2"},{"type":"function","title":"ExTwilio.SipDomain.do_new/2","doc":"","ref":"ExTwilio.SipDomain.html#do_new/2"},{"type":"function","title":"ExTwilio.SipDomain.find/2","doc":"","ref":"ExTwilio.SipDomain.html#find/2"},{"type":"function","title":"ExTwilio.SipDomain.new/0","doc":"","ref":"ExTwilio.SipDomain.html#new/0"},{"type":"function","title":"ExTwilio.SipDomain.new/1","doc":"","ref":"ExTwilio.SipDomain.html#new/1"},{"type":"function","title":"ExTwilio.SipDomain.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.SipDomain.html#parents/0"},{"type":"function","title":"ExTwilio.SipDomain.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.SipDomain.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.SipDomain.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.SipDomain.html#resource_name/0"},{"type":"function","title":"ExTwilio.SipDomain.stream/1","doc":"","ref":"ExTwilio.SipDomain.html#stream/1"},{"type":"function","title":"ExTwilio.SipDomain.update/3","doc":"","ref":"ExTwilio.SipDomain.html#update/3"},{"type":"module","title":"ExTwilio.SipIpAccessControlList","doc":"Represents an SIP IPAccessControlList in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/voice/sip/api/sip-ipaccesscontrollist-resource)","ref":"ExTwilio.SipIpAccessControlList.html"},{"type":"function","title":"ExTwilio.SipIpAccessControlList.all/1","doc":"","ref":"ExTwilio.SipIpAccessControlList.html#all/1"},{"type":"function","title":"ExTwilio.SipIpAccessControlList.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.SipIpAccessControlList.html#children/0"},{"type":"function","title":"ExTwilio.SipIpAccessControlList.create/2","doc":"","ref":"ExTwilio.SipIpAccessControlList.html#create/2"},{"type":"function","title":"ExTwilio.SipIpAccessControlList.destroy/2","doc":"","ref":"ExTwilio.SipIpAccessControlList.html#destroy/2"},{"type":"function","title":"ExTwilio.SipIpAccessControlList.do_new/2","doc":"","ref":"ExTwilio.SipIpAccessControlList.html#do_new/2"},{"type":"function","title":"ExTwilio.SipIpAccessControlList.find/2","doc":"","ref":"ExTwilio.SipIpAccessControlList.html#find/2"},{"type":"function","title":"ExTwilio.SipIpAccessControlList.new/0","doc":"","ref":"ExTwilio.SipIpAccessControlList.html#new/0"},{"type":"function","title":"ExTwilio.SipIpAccessControlList.new/1","doc":"","ref":"ExTwilio.SipIpAccessControlList.html#new/1"},{"type":"function","title":"ExTwilio.SipIpAccessControlList.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.SipIpAccessControlList.html#parents/0"},{"type":"function","title":"ExTwilio.SipIpAccessControlList.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.SipIpAccessControlList.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.SipIpAccessControlList.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.SipIpAccessControlList.html#resource_name/0"},{"type":"function","title":"ExTwilio.SipIpAccessControlList.stream/1","doc":"","ref":"ExTwilio.SipIpAccessControlList.html#stream/1"},{"type":"function","title":"ExTwilio.SipIpAccessControlList.update/3","doc":"","ref":"ExTwilio.SipIpAccessControlList.html#update/3"},{"type":"module","title":"ExTwilio.SipIpAddress","doc":"Represents an SIP IpAddress in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/voice/sip/api/sip-ipaccesscontrollist-resource#subresources)","ref":"ExTwilio.SipIpAddress.html"},{"type":"function","title":"ExTwilio.SipIpAddress.all/1","doc":"","ref":"ExTwilio.SipIpAddress.html#all/1"},{"type":"function","title":"ExTwilio.SipIpAddress.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.SipIpAddress.html#children/0"},{"type":"function","title":"ExTwilio.SipIpAddress.create/2","doc":"","ref":"ExTwilio.SipIpAddress.html#create/2"},{"type":"function","title":"ExTwilio.SipIpAddress.destroy/2","doc":"","ref":"ExTwilio.SipIpAddress.html#destroy/2"},{"type":"function","title":"ExTwilio.SipIpAddress.do_new/2","doc":"","ref":"ExTwilio.SipIpAddress.html#do_new/2"},{"type":"function","title":"ExTwilio.SipIpAddress.find/2","doc":"","ref":"ExTwilio.SipIpAddress.html#find/2"},{"type":"function","title":"ExTwilio.SipIpAddress.new/0","doc":"","ref":"ExTwilio.SipIpAddress.html#new/0"},{"type":"function","title":"ExTwilio.SipIpAddress.new/1","doc":"","ref":"ExTwilio.SipIpAddress.html#new/1"},{"type":"function","title":"ExTwilio.SipIpAddress.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.SipIpAddress.html#parents/0"},{"type":"function","title":"ExTwilio.SipIpAddress.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.SipIpAddress.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.SipIpAddress.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.SipIpAddress.html#resource_name/0"},{"type":"function","title":"ExTwilio.SipIpAddress.stream/1","doc":"","ref":"ExTwilio.SipIpAddress.html#stream/1"},{"type":"function","title":"ExTwilio.SipIpAddress.update/3","doc":"","ref":"ExTwilio.SipIpAddress.html#update/3"},{"type":"module","title":"ExTwilio.Studio.Execution","doc":"Represents a specific person's run through a Flow.\nAn execution is active while the user is in the Flow, and it is considered ended when they stop or are kicked out of the Flow.\n\n- [Twilio docs](https://www.twilio.com/docs/studio/rest-api/execution)","ref":"ExTwilio.Studio.Execution.html"},{"type":"function","title":"ExTwilio.Studio.Execution.all/1","doc":"","ref":"ExTwilio.Studio.Execution.html#all/1"},{"type":"function","title":"ExTwilio.Studio.Execution.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Studio.Execution.html#children/0"},{"type":"function","title":"ExTwilio.Studio.Execution.create/2","doc":"","ref":"ExTwilio.Studio.Execution.html#create/2"},{"type":"function","title":"ExTwilio.Studio.Execution.do_new/2","doc":"","ref":"ExTwilio.Studio.Execution.html#do_new/2"},{"type":"function","title":"ExTwilio.Studio.Execution.find/2","doc":"","ref":"ExTwilio.Studio.Execution.html#find/2"},{"type":"function","title":"ExTwilio.Studio.Execution.new/0","doc":"","ref":"ExTwilio.Studio.Execution.html#new/0"},{"type":"function","title":"ExTwilio.Studio.Execution.new/1","doc":"","ref":"ExTwilio.Studio.Execution.html#new/1"},{"type":"function","title":"ExTwilio.Studio.Execution.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Studio.Execution.html#parents/0"},{"type":"function","title":"ExTwilio.Studio.Execution.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Studio.Execution.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Studio.Execution.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Studio.Execution.html#resource_name/0"},{"type":"function","title":"ExTwilio.Studio.Execution.stream/1","doc":"","ref":"ExTwilio.Studio.Execution.html#stream/1"},{"type":"module","title":"ExTwilio.Studio.Flow","doc":"Represents an individual workflow that you create.\nThey can handle one or more use cases.\n\n- [Twilio docs](https://www.twilio.com/docs/studio/rest-api/flow)","ref":"ExTwilio.Studio.Flow.html"},{"type":"function","title":"ExTwilio.Studio.Flow.all/1","doc":"","ref":"ExTwilio.Studio.Flow.html#all/1"},{"type":"function","title":"ExTwilio.Studio.Flow.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Studio.Flow.html#children/0"},{"type":"function","title":"ExTwilio.Studio.Flow.do_new/2","doc":"","ref":"ExTwilio.Studio.Flow.html#do_new/2"},{"type":"function","title":"ExTwilio.Studio.Flow.find/2","doc":"","ref":"ExTwilio.Studio.Flow.html#find/2"},{"type":"function","title":"ExTwilio.Studio.Flow.new/0","doc":"","ref":"ExTwilio.Studio.Flow.html#new/0"},{"type":"function","title":"ExTwilio.Studio.Flow.new/1","doc":"","ref":"ExTwilio.Studio.Flow.html#new/1"},{"type":"function","title":"ExTwilio.Studio.Flow.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Studio.Flow.html#parents/0"},{"type":"function","title":"ExTwilio.Studio.Flow.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Studio.Flow.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Studio.Flow.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Studio.Flow.html#resource_name/0"},{"type":"function","title":"ExTwilio.Studio.Flow.stream/1","doc":"","ref":"ExTwilio.Studio.Flow.html#stream/1"},{"type":"module","title":"ExTwilio.Studio.Step","doc":"A Step is the runtime processing of a Widget, starting when that Widget is entered.\nVariables get set at the end of a Step.\n\n- [Twilio docs](https://www.twilio.com/docs/studio/rest-api/step)","ref":"ExTwilio.Studio.Step.html"},{"type":"function","title":"ExTwilio.Studio.Step.all/1","doc":"","ref":"ExTwilio.Studio.Step.html#all/1"},{"type":"function","title":"ExTwilio.Studio.Step.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Studio.Step.html#children/0"},{"type":"function","title":"ExTwilio.Studio.Step.do_new/2","doc":"","ref":"ExTwilio.Studio.Step.html#do_new/2"},{"type":"function","title":"ExTwilio.Studio.Step.find/2","doc":"","ref":"ExTwilio.Studio.Step.html#find/2"},{"type":"function","title":"ExTwilio.Studio.Step.new/0","doc":"","ref":"ExTwilio.Studio.Step.html#new/0"},{"type":"function","title":"ExTwilio.Studio.Step.new/1","doc":"","ref":"ExTwilio.Studio.Step.html#new/1"},{"type":"function","title":"ExTwilio.Studio.Step.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Studio.Step.html#parents/0"},{"type":"function","title":"ExTwilio.Studio.Step.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Studio.Step.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Studio.Step.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Studio.Step.html#resource_name/0"},{"type":"function","title":"ExTwilio.Studio.Step.stream/1","doc":"","ref":"ExTwilio.Studio.Step.html#stream/1"},{"type":"module","title":"ExTwilio.TaskRouter.Activity","doc":"Represents the current status of your workers. Workers can only have a single activity at a time.\n\n- [Twilio docs](https://www.twilio.com/docs/api/taskrouter/activities)","ref":"ExTwilio.TaskRouter.Activity.html"},{"type":"function","title":"ExTwilio.TaskRouter.Activity.all/1","doc":"","ref":"ExTwilio.TaskRouter.Activity.html#all/1"},{"type":"function","title":"ExTwilio.TaskRouter.Activity.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.Activity.html#children/0"},{"type":"function","title":"ExTwilio.TaskRouter.Activity.create/2","doc":"","ref":"ExTwilio.TaskRouter.Activity.html#create/2"},{"type":"function","title":"ExTwilio.TaskRouter.Activity.do_new/2","doc":"","ref":"ExTwilio.TaskRouter.Activity.html#do_new/2"},{"type":"function","title":"ExTwilio.TaskRouter.Activity.find/2","doc":"","ref":"ExTwilio.TaskRouter.Activity.html#find/2"},{"type":"function","title":"ExTwilio.TaskRouter.Activity.new/0","doc":"","ref":"ExTwilio.TaskRouter.Activity.html#new/0"},{"type":"function","title":"ExTwilio.TaskRouter.Activity.new/1","doc":"","ref":"ExTwilio.TaskRouter.Activity.html#new/1"},{"type":"function","title":"ExTwilio.TaskRouter.Activity.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.Activity.html#parents/0"},{"type":"function","title":"ExTwilio.TaskRouter.Activity.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.Activity.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.Activity.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.Activity.html#resource_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.Activity.stream/1","doc":"","ref":"ExTwilio.TaskRouter.Activity.html#stream/1"},{"type":"function","title":"ExTwilio.TaskRouter.Activity.update/3","doc":"","ref":"ExTwilio.TaskRouter.Activity.html#update/3"},{"type":"module","title":"ExTwilio.TaskRouter.Event","doc":"Represents the Event logs Twilio keeps track of.\n\n- [Twilio docs](https://www.twilio.com/docs/api/taskrouter/events)","ref":"ExTwilio.TaskRouter.Event.html"},{"type":"function","title":"ExTwilio.TaskRouter.Event.all/1","doc":"","ref":"ExTwilio.TaskRouter.Event.html#all/1"},{"type":"function","title":"ExTwilio.TaskRouter.Event.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.Event.html#children/0"},{"type":"function","title":"ExTwilio.TaskRouter.Event.do_new/2","doc":"","ref":"ExTwilio.TaskRouter.Event.html#do_new/2"},{"type":"function","title":"ExTwilio.TaskRouter.Event.find/2","doc":"","ref":"ExTwilio.TaskRouter.Event.html#find/2"},{"type":"function","title":"ExTwilio.TaskRouter.Event.new/0","doc":"","ref":"ExTwilio.TaskRouter.Event.html#new/0"},{"type":"function","title":"ExTwilio.TaskRouter.Event.new/1","doc":"","ref":"ExTwilio.TaskRouter.Event.html#new/1"},{"type":"function","title":"ExTwilio.TaskRouter.Event.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.Event.html#parents/0"},{"type":"function","title":"ExTwilio.TaskRouter.Event.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.Event.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.Event.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.Event.html#resource_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.Event.stream/1","doc":"","ref":"ExTwilio.TaskRouter.Event.html#stream/1"},{"type":"module","title":"ExTwilio.TaskRouter.Reservation","doc":"TaskRouter creates a Reservation subresource whenever a Task is reserved for a a Worker.\n\n- [Twilio docs](https://www.twilio.com/docs/api/taskrouter/reservations)","ref":"ExTwilio.TaskRouter.Reservation.html"},{"type":"function","title":"ExTwilio.TaskRouter.Reservation.all/1","doc":"","ref":"ExTwilio.TaskRouter.Reservation.html#all/1"},{"type":"function","title":"ExTwilio.TaskRouter.Reservation.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.Reservation.html#children/0"},{"type":"function","title":"ExTwilio.TaskRouter.Reservation.do_new/2","doc":"","ref":"ExTwilio.TaskRouter.Reservation.html#do_new/2"},{"type":"function","title":"ExTwilio.TaskRouter.Reservation.find/2","doc":"","ref":"ExTwilio.TaskRouter.Reservation.html#find/2"},{"type":"function","title":"ExTwilio.TaskRouter.Reservation.new/0","doc":"","ref":"ExTwilio.TaskRouter.Reservation.html#new/0"},{"type":"function","title":"ExTwilio.TaskRouter.Reservation.new/1","doc":"","ref":"ExTwilio.TaskRouter.Reservation.html#new/1"},{"type":"function","title":"ExTwilio.TaskRouter.Reservation.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.Reservation.html#parents/0"},{"type":"function","title":"ExTwilio.TaskRouter.Reservation.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.Reservation.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.Reservation.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.Reservation.html#resource_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.Reservation.stream/1","doc":"","ref":"ExTwilio.TaskRouter.Reservation.html#stream/1"},{"type":"function","title":"ExTwilio.TaskRouter.Reservation.update/3","doc":"","ref":"ExTwilio.TaskRouter.Reservation.html#update/3"},{"type":"module","title":"ExTwilio.TaskRouter.Task","doc":"A Task instance resource represents a single item of work waiting to be processed.\n\n- [Twilio docs](https://www.twilio.com/docs/api/taskrouter/tasks)","ref":"ExTwilio.TaskRouter.Task.html"},{"type":"function","title":"ExTwilio.TaskRouter.Task.all/1","doc":"","ref":"ExTwilio.TaskRouter.Task.html#all/1"},{"type":"function","title":"ExTwilio.TaskRouter.Task.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.Task.html#children/0"},{"type":"function","title":"ExTwilio.TaskRouter.Task.create/2","doc":"","ref":"ExTwilio.TaskRouter.Task.html#create/2"},{"type":"function","title":"ExTwilio.TaskRouter.Task.do_new/2","doc":"","ref":"ExTwilio.TaskRouter.Task.html#do_new/2"},{"type":"function","title":"ExTwilio.TaskRouter.Task.find/2","doc":"","ref":"ExTwilio.TaskRouter.Task.html#find/2"},{"type":"function","title":"ExTwilio.TaskRouter.Task.new/0","doc":"","ref":"ExTwilio.TaskRouter.Task.html#new/0"},{"type":"function","title":"ExTwilio.TaskRouter.Task.new/1","doc":"","ref":"ExTwilio.TaskRouter.Task.html#new/1"},{"type":"function","title":"ExTwilio.TaskRouter.Task.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.Task.html#parents/0"},{"type":"function","title":"ExTwilio.TaskRouter.Task.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.Task.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.Task.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.Task.html#resource_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.Task.stream/1","doc":"","ref":"ExTwilio.TaskRouter.Task.html#stream/1"},{"type":"function","title":"ExTwilio.TaskRouter.Task.update/3","doc":"","ref":"ExTwilio.TaskRouter.Task.html#update/3"},{"type":"module","title":"ExTwilio.TaskRouter.TaskQueue","doc":"TaskQueues are the resource you use to categorize Tasks\nand describe which Workers are eligible to handle those Tasks\n\n- [Twilio docs](https://www.twilio.com/docs/api/taskrouter/taskqueues)","ref":"ExTwilio.TaskRouter.TaskQueue.html"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueue.all/1","doc":"","ref":"ExTwilio.TaskRouter.TaskQueue.html#all/1"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueue.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.TaskQueue.html#children/0"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueue.create/2","doc":"","ref":"ExTwilio.TaskRouter.TaskQueue.html#create/2"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueue.do_new/2","doc":"","ref":"ExTwilio.TaskRouter.TaskQueue.html#do_new/2"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueue.find/2","doc":"","ref":"ExTwilio.TaskRouter.TaskQueue.html#find/2"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueue.new/0","doc":"","ref":"ExTwilio.TaskRouter.TaskQueue.html#new/0"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueue.new/1","doc":"","ref":"ExTwilio.TaskRouter.TaskQueue.html#new/1"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueue.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.TaskQueue.html#parents/0"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueue.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.TaskQueue.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueue.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.TaskQueue.html#resource_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueue.stream/1","doc":"","ref":"ExTwilio.TaskRouter.TaskQueue.html#stream/1"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueue.update/3","doc":"","ref":"ExTwilio.TaskRouter.TaskQueue.html#update/3"},{"type":"module","title":"ExTwilio.TaskRouter.TaskQueueStatistic","doc":"Realtime and historical statistics for TaskQueues\n\n- [Twilio docs](https://www.twilio.com/docs/api/taskrouter/taskqueue-statistics)","ref":"ExTwilio.TaskRouter.TaskQueueStatistic.html"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueueStatistic.all/1","doc":"","ref":"ExTwilio.TaskRouter.TaskQueueStatistic.html#all/1"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueueStatistic.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.TaskQueueStatistic.html#children/0"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueueStatistic.do_new/2","doc":"","ref":"ExTwilio.TaskRouter.TaskQueueStatistic.html#do_new/2"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueueStatistic.new/0","doc":"","ref":"ExTwilio.TaskRouter.TaskQueueStatistic.html#new/0"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueueStatistic.new/1","doc":"","ref":"ExTwilio.TaskRouter.TaskQueueStatistic.html#new/1"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueueStatistic.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.TaskQueueStatistic.html#parents/0"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueueStatistic.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.TaskQueueStatistic.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueueStatistic.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.TaskQueueStatistic.html#resource_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.TaskQueueStatistic.stream/1","doc":"","ref":"ExTwilio.TaskRouter.TaskQueueStatistic.html#stream/1"},{"type":"module","title":"ExTwilio.TaskRouter.Worker","doc":"Represents a worker resource who preforms tasks.\n\n- [Twilio docs](https://www.twilio.com/docs/api/taskrouter/workers)","ref":"ExTwilio.TaskRouter.Worker.html"},{"type":"function","title":"ExTwilio.TaskRouter.Worker.all/1","doc":"","ref":"ExTwilio.TaskRouter.Worker.html#all/1"},{"type":"function","title":"ExTwilio.TaskRouter.Worker.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.Worker.html#children/0"},{"type":"function","title":"ExTwilio.TaskRouter.Worker.create/2","doc":"","ref":"ExTwilio.TaskRouter.Worker.html#create/2"},{"type":"function","title":"ExTwilio.TaskRouter.Worker.do_new/2","doc":"","ref":"ExTwilio.TaskRouter.Worker.html#do_new/2"},{"type":"function","title":"ExTwilio.TaskRouter.Worker.find/2","doc":"","ref":"ExTwilio.TaskRouter.Worker.html#find/2"},{"type":"function","title":"ExTwilio.TaskRouter.Worker.new/0","doc":"","ref":"ExTwilio.TaskRouter.Worker.html#new/0"},{"type":"function","title":"ExTwilio.TaskRouter.Worker.new/1","doc":"","ref":"ExTwilio.TaskRouter.Worker.html#new/1"},{"type":"function","title":"ExTwilio.TaskRouter.Worker.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.Worker.html#parents/0"},{"type":"function","title":"ExTwilio.TaskRouter.Worker.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.Worker.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.Worker.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.Worker.html#resource_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.Worker.stream/1","doc":"","ref":"ExTwilio.TaskRouter.Worker.html#stream/1"},{"type":"function","title":"ExTwilio.TaskRouter.Worker.update/3","doc":"","ref":"ExTwilio.TaskRouter.Worker.html#update/3"},{"type":"module","title":"ExTwilio.TaskRouter.WorkerStatistic","doc":"TaskRouter provides real time and historical statistics for Workers.\n\n- [Twilio docs](https://www.twilio.com/docs/api/taskrouter/worker-statistics)","ref":"ExTwilio.TaskRouter.WorkerStatistic.html"},{"type":"function","title":"ExTwilio.TaskRouter.WorkerStatistic.all/1","doc":"","ref":"ExTwilio.TaskRouter.WorkerStatistic.html#all/1"},{"type":"function","title":"ExTwilio.TaskRouter.WorkerStatistic.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.WorkerStatistic.html#children/0"},{"type":"function","title":"ExTwilio.TaskRouter.WorkerStatistic.do_new/2","doc":"","ref":"ExTwilio.TaskRouter.WorkerStatistic.html#do_new/2"},{"type":"function","title":"ExTwilio.TaskRouter.WorkerStatistic.find/2","doc":"","ref":"ExTwilio.TaskRouter.WorkerStatistic.html#find/2"},{"type":"function","title":"ExTwilio.TaskRouter.WorkerStatistic.new/0","doc":"","ref":"ExTwilio.TaskRouter.WorkerStatistic.html#new/0"},{"type":"function","title":"ExTwilio.TaskRouter.WorkerStatistic.new/1","doc":"","ref":"ExTwilio.TaskRouter.WorkerStatistic.html#new/1"},{"type":"function","title":"ExTwilio.TaskRouter.WorkerStatistic.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.WorkerStatistic.html#parents/0"},{"type":"function","title":"ExTwilio.TaskRouter.WorkerStatistic.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.WorkerStatistic.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.WorkerStatistic.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.WorkerStatistic.html#resource_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.WorkerStatistic.stream/1","doc":"","ref":"ExTwilio.TaskRouter.WorkerStatistic.html#stream/1"},{"type":"module","title":"ExTwilio.TaskRouter.Workflow","doc":"Represents a workflow that controls how tasks will be prioritized and routed into queues.\n\n- [Twilio docs](https://www.twilio.com/docs/api/taskrouter/workflows)","ref":"ExTwilio.TaskRouter.Workflow.html"},{"type":"function","title":"ExTwilio.TaskRouter.Workflow.all/1","doc":"","ref":"ExTwilio.TaskRouter.Workflow.html#all/1"},{"type":"function","title":"ExTwilio.TaskRouter.Workflow.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.Workflow.html#children/0"},{"type":"function","title":"ExTwilio.TaskRouter.Workflow.create/2","doc":"","ref":"ExTwilio.TaskRouter.Workflow.html#create/2"},{"type":"function","title":"ExTwilio.TaskRouter.Workflow.do_new/2","doc":"","ref":"ExTwilio.TaskRouter.Workflow.html#do_new/2"},{"type":"function","title":"ExTwilio.TaskRouter.Workflow.find/2","doc":"","ref":"ExTwilio.TaskRouter.Workflow.html#find/2"},{"type":"function","title":"ExTwilio.TaskRouter.Workflow.new/0","doc":"","ref":"ExTwilio.TaskRouter.Workflow.html#new/0"},{"type":"function","title":"ExTwilio.TaskRouter.Workflow.new/1","doc":"","ref":"ExTwilio.TaskRouter.Workflow.html#new/1"},{"type":"function","title":"ExTwilio.TaskRouter.Workflow.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.Workflow.html#parents/0"},{"type":"function","title":"ExTwilio.TaskRouter.Workflow.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.Workflow.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.Workflow.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.Workflow.html#resource_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.Workflow.stream/1","doc":"","ref":"ExTwilio.TaskRouter.Workflow.html#stream/1"},{"type":"function","title":"ExTwilio.TaskRouter.Workflow.update/3","doc":"","ref":"ExTwilio.TaskRouter.Workflow.html#update/3"},{"type":"module","title":"ExTwilio.TaskRouter.WorkflowStatistic","doc":"Represents a resource that provides statistics on workflows.\n\n- [Twilio docs](https://www.twilio.com/docs/api/taskrouter/workflow-statistics)","ref":"ExTwilio.TaskRouter.WorkflowStatistic.html"},{"type":"function","title":"ExTwilio.TaskRouter.WorkflowStatistic.all/1","doc":"","ref":"ExTwilio.TaskRouter.WorkflowStatistic.html#all/1"},{"type":"function","title":"ExTwilio.TaskRouter.WorkflowStatistic.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.WorkflowStatistic.html#children/0"},{"type":"function","title":"ExTwilio.TaskRouter.WorkflowStatistic.do_new/2","doc":"","ref":"ExTwilio.TaskRouter.WorkflowStatistic.html#do_new/2"},{"type":"function","title":"ExTwilio.TaskRouter.WorkflowStatistic.new/0","doc":"","ref":"ExTwilio.TaskRouter.WorkflowStatistic.html#new/0"},{"type":"function","title":"ExTwilio.TaskRouter.WorkflowStatistic.new/1","doc":"","ref":"ExTwilio.TaskRouter.WorkflowStatistic.html#new/1"},{"type":"function","title":"ExTwilio.TaskRouter.WorkflowStatistic.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.WorkflowStatistic.html#parents/0"},{"type":"function","title":"ExTwilio.TaskRouter.WorkflowStatistic.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.WorkflowStatistic.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.WorkflowStatistic.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.WorkflowStatistic.html#resource_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.WorkflowStatistic.stream/1","doc":"","ref":"ExTwilio.TaskRouter.WorkflowStatistic.html#stream/1"},{"type":"module","title":"ExTwilio.TaskRouter.Workspace","doc":"A Workspace is a container for your Tasks, Workers, TaskQueues, Workflows and Activities.\n\nEach of these items exists within a single Workspace and will not be shared across Workspaces.\n\n- [Twilio docs](https://www.twilio.com/docs/api/taskrouter/workspaces)","ref":"ExTwilio.TaskRouter.Workspace.html"},{"type":"function","title":"ExTwilio.TaskRouter.Workspace.all/1","doc":"","ref":"ExTwilio.TaskRouter.Workspace.html#all/1"},{"type":"function","title":"ExTwilio.TaskRouter.Workspace.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.Workspace.html#children/0"},{"type":"function","title":"ExTwilio.TaskRouter.Workspace.create/2","doc":"","ref":"ExTwilio.TaskRouter.Workspace.html#create/2"},{"type":"function","title":"ExTwilio.TaskRouter.Workspace.do_new/2","doc":"","ref":"ExTwilio.TaskRouter.Workspace.html#do_new/2"},{"type":"function","title":"ExTwilio.TaskRouter.Workspace.find/2","doc":"","ref":"ExTwilio.TaskRouter.Workspace.html#find/2"},{"type":"function","title":"ExTwilio.TaskRouter.Workspace.new/0","doc":"","ref":"ExTwilio.TaskRouter.Workspace.html#new/0"},{"type":"function","title":"ExTwilio.TaskRouter.Workspace.new/1","doc":"","ref":"ExTwilio.TaskRouter.Workspace.html#new/1"},{"type":"function","title":"ExTwilio.TaskRouter.Workspace.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.Workspace.html#parents/0"},{"type":"function","title":"ExTwilio.TaskRouter.Workspace.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.Workspace.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.Workspace.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.Workspace.html#resource_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.Workspace.stream/1","doc":"","ref":"ExTwilio.TaskRouter.Workspace.html#stream/1"},{"type":"function","title":"ExTwilio.TaskRouter.Workspace.update/3","doc":"","ref":"ExTwilio.TaskRouter.Workspace.html#update/3"},{"type":"module","title":"ExTwilio.TaskRouter.WorkspaceStatistic","doc":"Provides real time and historical statistics for Workspaces.\n\n- [Twilio docs](https://www.twilio.com/docs/api/taskrouter/workspace-statistics)","ref":"ExTwilio.TaskRouter.WorkspaceStatistic.html"},{"type":"function","title":"ExTwilio.TaskRouter.WorkspaceStatistic.all/1","doc":"","ref":"ExTwilio.TaskRouter.WorkspaceStatistic.html#all/1"},{"type":"function","title":"ExTwilio.TaskRouter.WorkspaceStatistic.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.WorkspaceStatistic.html#children/0"},{"type":"function","title":"ExTwilio.TaskRouter.WorkspaceStatistic.do_new/2","doc":"","ref":"ExTwilio.TaskRouter.WorkspaceStatistic.html#do_new/2"},{"type":"function","title":"ExTwilio.TaskRouter.WorkspaceStatistic.new/0","doc":"","ref":"ExTwilio.TaskRouter.WorkspaceStatistic.html#new/0"},{"type":"function","title":"ExTwilio.TaskRouter.WorkspaceStatistic.new/1","doc":"","ref":"ExTwilio.TaskRouter.WorkspaceStatistic.html#new/1"},{"type":"function","title":"ExTwilio.TaskRouter.WorkspaceStatistic.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.TaskRouter.WorkspaceStatistic.html#parents/0"},{"type":"function","title":"ExTwilio.TaskRouter.WorkspaceStatistic.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.WorkspaceStatistic.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.WorkspaceStatistic.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.TaskRouter.WorkspaceStatistic.html#resource_name/0"},{"type":"function","title":"ExTwilio.TaskRouter.WorkspaceStatistic.stream/1","doc":"","ref":"ExTwilio.TaskRouter.WorkspaceStatistic.html#stream/1"},{"type":"module","title":"ExTwilio.Token","doc":"Represents a Token resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/iam/access-tokens)","ref":"ExTwilio.Token.html"},{"type":"function","title":"ExTwilio.Token.all/1","doc":"","ref":"ExTwilio.Token.html#all/1"},{"type":"function","title":"ExTwilio.Token.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Token.html#children/0"},{"type":"function","title":"ExTwilio.Token.create/2","doc":"","ref":"ExTwilio.Token.html#create/2"},{"type":"function","title":"ExTwilio.Token.do_new/2","doc":"","ref":"ExTwilio.Token.html#do_new/2"},{"type":"function","title":"ExTwilio.Token.new/0","doc":"","ref":"ExTwilio.Token.html#new/0"},{"type":"function","title":"ExTwilio.Token.new/1","doc":"","ref":"ExTwilio.Token.html#new/1"},{"type":"function","title":"ExTwilio.Token.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Token.html#parents/0"},{"type":"function","title":"ExTwilio.Token.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Token.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Token.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Token.html#resource_name/0"},{"type":"function","title":"ExTwilio.Token.stream/1","doc":"","ref":"ExTwilio.Token.html#stream/1"},{"type":"module","title":"ExTwilio.Transcription","doc":"Represents a Transcription resource in the Twilio API.\n\n- [Twilio docs](https://www.twilio.com/docs/voice/api/recording-transcription)","ref":"ExTwilio.Transcription.html"},{"type":"function","title":"ExTwilio.Transcription.all/1","doc":"","ref":"ExTwilio.Transcription.html#all/1"},{"type":"function","title":"ExTwilio.Transcription.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Transcription.html#children/0"},{"type":"function","title":"ExTwilio.Transcription.destroy/2","doc":"","ref":"ExTwilio.Transcription.html#destroy/2"},{"type":"function","title":"ExTwilio.Transcription.do_new/2","doc":"","ref":"ExTwilio.Transcription.html#do_new/2"},{"type":"function","title":"ExTwilio.Transcription.find/2","doc":"","ref":"ExTwilio.Transcription.html#find/2"},{"type":"function","title":"ExTwilio.Transcription.new/0","doc":"","ref":"ExTwilio.Transcription.html#new/0"},{"type":"function","title":"ExTwilio.Transcription.new/1","doc":"","ref":"ExTwilio.Transcription.html#new/1"},{"type":"function","title":"ExTwilio.Transcription.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Transcription.html#parents/0"},{"type":"function","title":"ExTwilio.Transcription.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Transcription.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Transcription.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Transcription.html#resource_name/0"},{"type":"function","title":"ExTwilio.Transcription.stream/1","doc":"","ref":"ExTwilio.Transcription.html#stream/1"},{"type":"module","title":"ExTwilio.UrlGenerator","doc":"Generates Twilio URLs for modules. See `build_url/3` for more information.","ref":"ExTwilio.UrlGenerator.html"},{"type":"function","title":"ExTwilio.UrlGenerator.build_url/3","doc":"Infers the proper Twilio URL for a resource when given a module, an optional\nSID, and a list of options.\n\nNote that the module should have the following two functions:\n\n- `resource_name/0`\n- `resource_collection_name/0`\n\n# Examples\n\n    iex> build_url(Resource)\n    \"https://api.twilio.com/2010-04-01/Accounts/ /Resources.json\"\n\n    iex> build_url(Resource, nil, account: 2)\n    \"https://api.twilio.com/2010-04-01/Accounts/2/Resources.json\"\n\n    iex> build_url(Resource, 1, account: 2)\n    \"https://api.twilio.com/2010-04-01/Accounts/2/Resources/1.json\"\n\n    iex> build_url(Resource, 1)\n    \"https://api.twilio.com/2010-04-01/Accounts/ /Resources/1.json\"\n\n    iex> build_url(Resource, nil, page: 20)\n    \"https://api.twilio.com/2010-04-01/Accounts/ /Resources.json?Page=20\"\n\n    iex> build_url(Resource, nil, iso_country_code: \"US\", type: \"Mobile\", page: 20)\n    \"https://api.twilio.com/2010-04-01/Accounts/ /Resources/US/Mobile.json?Page=20\"\n\n    iex> build_url(Resource, 1, sip_ip_access_control_list: \"list\", account: \"account_sid\")\n    \"https://api.twilio.com/2010-04-01/Accounts/account_sid/SIP/IpAccessControlLists/list/Resources/1.json\"","ref":"ExTwilio.UrlGenerator.html#build_url/3"},{"type":"function","title":"ExTwilio.UrlGenerator.resource_collection_name/1","doc":"Infer a lowercase and underscore collection name for a module.","ref":"ExTwilio.UrlGenerator.html#resource_collection_name/1"},{"type":"function","title":"Examples - ExTwilio.UrlGenerator.resource_collection_name/1","doc":"iex> ExTwilio.UrlGenerator.resource_collection_name(Resource)\n    \"resources\"","ref":"ExTwilio.UrlGenerator.html#resource_collection_name/1-examples"},{"type":"function","title":"ExTwilio.UrlGenerator.resource_name/1","doc":"Converts a module name into a pluralized Twilio-compatible resource name.","ref":"ExTwilio.UrlGenerator.html#resource_name/1"},{"type":"function","title":"Examples - ExTwilio.UrlGenerator.resource_name/1","doc":"iex> ExTwilio.UrlGenerator.resource_name(:\"Elixir.ExTwilio.Call\")\n    \"Calls\"\n\n    # Uses only the last segment of the module name\n    iex> ExTwilio.UrlGenerator.resource_name(:\"ExTwilio.Resources.Call\")\n    \"Calls\"","ref":"ExTwilio.UrlGenerator.html#resource_name/1-examples"},{"type":"function","title":"ExTwilio.UrlGenerator.to_query_string/1","doc":"Generate a list of querystring parameters for a url from an Elixir list.","ref":"ExTwilio.UrlGenerator.html#to_query_string/1"},{"type":"function","title":"Examples - ExTwilio.UrlGenerator.to_query_string/1","doc":"iex> ExTwilio.UrlGenerator.to_query_string([hello: \"world\", how_are: \"you\"])\n    \"Hello=world&HowAre=you\"","ref":"ExTwilio.UrlGenerator.html#to_query_string/1-examples"},{"type":"module","title":"ExTwilio.Video.Room","doc":"Represents a programmable video Room.\n\n- [Twilio docs](https://www.twilio.com/docs/video/api/rooms-resource)","ref":"ExTwilio.Video.Room.html"},{"type":"function","title":"ExTwilio.Video.Room.all/1","doc":"","ref":"ExTwilio.Video.Room.html#all/1"},{"type":"function","title":"ExTwilio.Video.Room.children/0","doc":"Children represent path segments that come after the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users/Active` \"Active\" is\na child.  Children may or may not have a key in the next segment.\n\nOverride this method in your resource to specify children in the order that they will appear\nin the path.","ref":"ExTwilio.Video.Room.html#children/0"},{"type":"function","title":"ExTwilio.Video.Room.complete/1","doc":"","ref":"ExTwilio.Video.Room.html#complete/1"},{"type":"function","title":"ExTwilio.Video.Room.create/2","doc":"","ref":"ExTwilio.Video.Room.html#create/2"},{"type":"function","title":"ExTwilio.Video.Room.do_new/2","doc":"","ref":"ExTwilio.Video.Room.html#do_new/2"},{"type":"function","title":"ExTwilio.Video.Room.find/2","doc":"","ref":"ExTwilio.Video.Room.html#find/2"},{"type":"function","title":"ExTwilio.Video.Room.new/0","doc":"","ref":"ExTwilio.Video.Room.html#new/0"},{"type":"function","title":"ExTwilio.Video.Room.new/1","doc":"","ref":"ExTwilio.Video.Room.html#new/1"},{"type":"function","title":"ExTwilio.Video.Room.parents/0","doc":"Parents represent path segments that precede the current resource. For example,\nin the path `/v2/Services/ISXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX/Users` \"Services\" is\na parent.  Parents will always have a key in the next segment.  If your parent is under a\nsubmodule of `ExTwilio`, specify your parent using the `ExTwilio.Parent` struct.\n\nOverride this method in your resource to specify parents in the order that they will appear\nin the path.","ref":"ExTwilio.Video.Room.html#parents/0"},{"type":"function","title":"ExTwilio.Video.Room.resource_collection_name/0","doc":"Underscored and lowercased collection name for a given resource.\nDelegates the real work to `ExTwilio.UrlGenerator.resource_collection_name/1` by\ndefault.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Video.Room.html#resource_collection_name/0"},{"type":"function","title":"ExTwilio.Video.Room.resource_name/0","doc":"CamelCase resource name as it would be used in Twilio's API. Delegates\nthe real work to `ExTwilio.UrlGenerator.resource_name/1` by default.\n\nOverride in your module after `use ExTwilio.Resource` if you need\nsomething different.","ref":"ExTwilio.Video.Room.html#resource_name/0"},{"type":"function","title":"ExTwilio.Video.Room.stream/1","doc":"","ref":"ExTwilio.Video.Room.html#stream/1"},{"type":"function","title":"ExTwilio.Video.Room.update/3","doc":"","ref":"ExTwilio.Video.Room.html#update/3"},{"type":"module","title":"ExTwilio.WorkerCapability","doc":"Capability tokens are used to sign communications from devices to Twilio.\n\nYou create a token on your server, specify what capabilities you would like\nyour device to have, then pass the token to your client to use. The tokens\ngenerated are JSON Web Tokens (JWT).\n\n- [Capability docs](https://www.twilio.com/docs/api/client/capability-tokens)\n- [JWT docs](https://jwt.io/introduction/)","ref":"ExTwilio.WorkerCapability.html"},{"type":"module","title":"Examples - ExTwilio.WorkerCapability","doc":"ExTwilio.WorkerCapability.new(\"worker_sid\", \"workspace_sid\")\n    |> ExTwilio.WorkerCapability.token\n    \"xxxxx.yyyyy.zzzzz\"","ref":"ExTwilio.WorkerCapability.html#module-examples"},{"type":"function","title":"ExTwilio.WorkerCapability.allow/5","doc":"","ref":"ExTwilio.WorkerCapability.html#allow/5"},{"type":"function","title":"ExTwilio.WorkerCapability.allow_activity_updates/1","doc":"","ref":"ExTwilio.WorkerCapability.html#allow_activity_updates/1"},{"type":"function","title":"ExTwilio.WorkerCapability.allow_reservation_updates/1","doc":"","ref":"ExTwilio.WorkerCapability.html#allow_reservation_updates/1"},{"type":"function","title":"ExTwilio.WorkerCapability.generate_and_sign/2","doc":"Combines `generate_claims/1` and `encode_and_sign/2`","ref":"ExTwilio.WorkerCapability.html#generate_and_sign/2"},{"type":"function","title":"ExTwilio.WorkerCapability.generate_and_sign!/2","doc":"Same as `generate_and_sign/2` but raises if error","ref":"ExTwilio.WorkerCapability.html#generate_and_sign!/2"},{"type":"function","title":"ExTwilio.WorkerCapability.new/2","doc":"Initialises a new capability specification with a TTL of one hour,\nand the accound sid and auth token taken from the configuration.","ref":"ExTwilio.WorkerCapability.html#new/2"},{"type":"function","title":"Examples - ExTwilio.WorkerCapability.new/2","doc":"ExTwilio.WorkerCapability.new","ref":"ExTwilio.WorkerCapability.html#new/2-examples"},{"type":"function","title":"ExTwilio.WorkerCapability.starting_at/2","doc":"Sets the time at which the TTL begins in seconds since epoch.","ref":"ExTwilio.WorkerCapability.html#starting_at/2"},{"type":"function","title":"Examples - ExTwilio.WorkerCapability.starting_at/2","doc":"Sets the TTL to begin on 24th May, 2016:\n\n    ExTwilio.WorkerCapability.starting_at(1464096368)","ref":"ExTwilio.WorkerCapability.html#starting_at/2-examples"},{"type":"function","title":"ExTwilio.WorkerCapability.token/1","doc":"Generates a JWT token based on the requested policies.","ref":"ExTwilio.WorkerCapability.html#token/1"},{"type":"function","title":"Examples - ExTwilio.WorkerCapability.token/1","doc":"Generates and signs a token with the provided capabilities:\n\n    ExTwilio.WorkerCapability.token","ref":"ExTwilio.WorkerCapability.html#token/1-examples"},{"type":"function","title":"ExTwilio.WorkerCapability.verify_and_validate/3","doc":"Combines `verify/2` and `validate/2`","ref":"ExTwilio.WorkerCapability.html#verify_and_validate/3"},{"type":"function","title":"ExTwilio.WorkerCapability.verify_and_validate!/3","doc":"Same as `verify_and_validate/2` but raises if error","ref":"ExTwilio.WorkerCapability.html#verify_and_validate!/3"},{"type":"function","title":"ExTwilio.WorkerCapability.with_account_sid/2","doc":"Sets the Twilio account sid used to issue the token.","ref":"ExTwilio.WorkerCapability.html#with_account_sid/2"},{"type":"function","title":"Examples - ExTwilio.WorkerCapability.with_account_sid/2","doc":"Sets the account sid to be XXX:\n\n    ExTwilio.WorkerCapability.with_account_sid('XXX')","ref":"ExTwilio.WorkerCapability.html#with_account_sid/2-examples"},{"type":"function","title":"ExTwilio.WorkerCapability.with_auth_token/2","doc":"Sets the Twilio account auth token used to sign the capability token.","ref":"ExTwilio.WorkerCapability.html#with_auth_token/2"},{"type":"function","title":"Examples - ExTwilio.WorkerCapability.with_auth_token/2","doc":"Sets the auth token to be XXX:\n\n    ExTwilio.WorkerCapability.with_auth_token('XXX')","ref":"ExTwilio.WorkerCapability.html#with_auth_token/2-examples"},{"type":"function","title":"ExTwilio.WorkerCapability.with_ttl/2","doc":"Sets the TTL of the token in seconds.\n\n- [TTL docs](https://www.twilio.com/docs/api/client/capability-tokens#token-expiration)","ref":"ExTwilio.WorkerCapability.html#with_ttl/2"},{"type":"function","title":"Examples - ExTwilio.WorkerCapability.with_ttl/2","doc":"Sets the TTL to one hour:\n\n    ExTwilio.WorkerCapability.with_ttl(3600)","ref":"ExTwilio.WorkerCapability.html#with_ttl/2-examples"},{"type":"function","title":"ExTwilio.WorkerCapability.with_worker_sid/2","doc":"Sets the Twilio worker sid used to sign the capability token.","ref":"ExTwilio.WorkerCapability.html#with_worker_sid/2"},{"type":"function","title":"Examples - ExTwilio.WorkerCapability.with_worker_sid/2","doc":"Sets the worker sid to be XXX:\n\n    ExTwilio.WorkerCapability.with_worker_sid('XXX')","ref":"ExTwilio.WorkerCapability.html#with_worker_sid/2-examples"},{"type":"function","title":"ExTwilio.WorkerCapability.with_workspace_sid/2","doc":"Sets the Twilio workspace sid used to sign the capability token.","ref":"ExTwilio.WorkerCapability.html#with_workspace_sid/2"},{"type":"function","title":"Examples - ExTwilio.WorkerCapability.with_workspace_sid/2","doc":"Sets the workspace sid to be XXX:\n\n    ExTwilio.WorkerCapability.with_workspace_sid('XXX')","ref":"ExTwilio.WorkerCapability.html#with_workspace_sid/2-examples"},{"type":"type","title":"ExTwilio.WorkerCapability.t/0","doc":"","ref":"ExTwilio.WorkerCapability.html#t:t/0"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\n## [0.10.0](https://github.com/danielberkompas/ex_twilio/tree/0.10.0) (2024-04-05)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.9.1...0.10.0)\n\n**Closed issues:**\n\n- Add support for Proxy API [\\#162](https://github.com/danielberkompas/ex_twilio/issues/162)\n- http client adapter/behavior [\\#161](https://github.com/danielberkompas/ex_twilio/issues/161)\n- Allow configurable urls. [\\#160](https://github.com/danielberkompas/ex_twilio/issues/160)\n\n**Merged pull requests:**\n\n- Fix deprecation warnings on modern Elixir [\\#181](https://github.com/danielberkompas/ex_twilio/pull/181) ([danielberkompas](https://github.com/danielberkompas))\n- Misc doc changes [\\#145](https://github.com/danielberkompas/ex_twilio/pull/145) ([kianmeng](https://github.com/kianmeng))\n\n## [v0.9.1](https://github.com/danielberkompas/ex_twilio/tree/v0.9.1) (2021-06-05)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.9.0...v0.9.1)\n\n**Closed issues:**\n\n- Not compatible with Erlang/OTP 24 [\\#155](https://github.com/danielberkompas/ex_twilio/issues/155)\n- HTTPoison error Fatal - Unknown CA.  [\\#151](https://github.com/danielberkompas/ex_twilio/issues/151)\n\n**Merged pull requests:**\n\n- Run tests against Erlang 24, Elixir 1.12 [\\#156](https://github.com/danielberkompas/ex_twilio/pull/156) ([danielberkompas](https://github.com/danielberkompas))\n- fix\\(deprecation\\): :crypto.hmac -\\> :crypto.mac, Bitwise.^^^ -\\> Bitwise.bxor [\\#154](https://github.com/danielberkompas/ex_twilio/pull/154) ([seantanly](https://github.com/seantanly))\n- Fix dialyzer errors [\\#150](https://github.com/danielberkompas/ex_twilio/pull/150) ([drgmr](https://github.com/drgmr))\n- Documentation Clarification [\\#149](https://github.com/danielberkompas/ex_twilio/pull/149) ([imrying](https://github.com/imrying))\n- Use Semaphore for CI [\\#146](https://github.com/danielberkompas/ex_twilio/pull/146) ([danielberkompas](https://github.com/danielberkompas))\n\n## [v0.9.0](https://github.com/danielberkompas/ex_twilio/tree/v0.9.0) (2021-02-05)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.8.2...v0.9.0)\n\n**Merged pull requests:**\n\n- Replace Poison with Jason [\\#143](https://github.com/danielberkompas/ex_twilio/pull/143) ([tomciopp](https://github.com/tomciopp))\n- Allow request options to be configured for HTTPoison/hackney Twilio requests [\\#141](https://github.com/danielberkompas/ex_twilio/pull/141) ([paulanthonywilson](https://github.com/paulanthonywilson))\n\n## [v0.8.2](https://github.com/danielberkompas/ex_twilio/tree/v0.8.2) (2020-10-01)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.8.1...v0.8.2)\n\n**Fixed bugs:**\n\n- problem with AvailablePhoneNumbers.all [\\#96](https://github.com/danielberkompas/ex_twilio/issues/96)\n- Getting error after creating/sending message [\\#37](https://github.com/danielberkompas/ex_twilio/issues/37)\n\n**Closed issues:**\n\n- Add :enabled option to config [\\#138](https://github.com/danielberkompas/ex_twilio/issues/138)\n- Where is the documentation for making the webhook receive incoming SMS messages? [\\#135](https://github.com/danielberkompas/ex_twilio/issues/135)\n- RequestValidator returns false, even when the strings both match [\\#133](https://github.com/danielberkompas/ex_twilio/issues/133)\n- leaking `{ssl_closed, _}` messages from httpoison/hackney [\\#132](https://github.com/danielberkompas/ex_twilio/issues/132)\n- Thank you for building this! [\\#130](https://github.com/danielberkompas/ex_twilio/issues/130)\n- Support for multiple accounts [\\#126](https://github.com/danielberkompas/ex_twilio/issues/126)\n- Config question with 1.9 coming - this is not an issue, just a question. [\\#118](https://github.com/danielberkompas/ex_twilio/issues/118)\n- ExTwilio.Signature for creating a \"x-twilio-signiture\" string [\\#108](https://github.com/danielberkompas/ex_twilio/issues/108)\n- Doesn't work with Dotenv [\\#63](https://github.com/danielberkompas/ex_twilio/issues/63)\n\n**Merged pull requests:**\n\n- Update participant resource [\\#140](https://github.com/danielberkompas/ex_twilio/pull/140) ([rrebane](https://github.com/rrebane))\n- Add Rooms resource [\\#139](https://github.com/danielberkompas/ex_twilio/pull/139) ([dshvimer2](https://github.com/dshvimer2))\n- Fix typos [\\#136](https://github.com/danielberkompas/ex_twilio/pull/136) ([yakryder](https://github.com/yakryder))\n- Add voice grant [\\#134](https://github.com/danielberkompas/ex_twilio/pull/134) ([ostap0207](https://github.com/ostap0207))\n\n## [v0.8.1](https://github.com/danielberkompas/ex_twilio/tree/v0.8.1) (2019-12-06)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.8.0...v0.8.1)\n\n**Merged pull requests:**\n\n- Update broken and redirected links [\\#131](https://github.com/danielberkompas/ex_twilio/pull/131) ([dikaio](https://github.com/dikaio))\n\n## [v0.8.0](https://github.com/danielberkompas/ex_twilio/tree/v0.8.0) (2019-11-28)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.7.0...v0.8.0)\n\n**Closed issues:**\n\n- SMS opt-out [\\#127](https://github.com/danielberkompas/ex_twilio/issues/127)\n- No status callbacks for sms [\\#120](https://github.com/danielberkompas/ex_twilio/issues/120)\n\n**Merged pull requests:**\n\n- chore\\(JSON\\): Allow people to use the most recent version of Poison, r… [\\#129](https://github.com/danielberkompas/ex_twilio/pull/129) ([tomciopp](https://github.com/tomciopp))\n- Add Studio Flow Execution + Step [\\#125](https://github.com/danielberkompas/ex_twilio/pull/125) ([jc00ke](https://github.com/jc00ke))\n- Bump Inflex to 2.0 [\\#123](https://github.com/danielberkompas/ex_twilio/pull/123) ([kiere](https://github.com/kiere))\n- Add new fields to incoming phone number resources [\\#122](https://github.com/danielberkompas/ex_twilio/pull/122) ([ferd](https://github.com/ferd))\n- Add Fax resource [\\#119](https://github.com/danielberkompas/ex_twilio/pull/119) ([schneiderderek](https://github.com/schneiderderek))\n- Add support for Video Grants in Access tokens [\\#117](https://github.com/danielberkompas/ex_twilio/pull/117) ([arielo](https://github.com/arielo))\n- Add status, identity\\_sid to IncomingPhoneNumber fields [\\#116](https://github.com/danielberkompas/ex_twilio/pull/116) ([novaugust](https://github.com/novaugust))\n- remove \"list\" function mentions [\\#115](https://github.com/danielberkompas/ex_twilio/pull/115) ([gliush](https://github.com/gliush))\n\n## [v0.7.0](https://github.com/danielberkompas/ex_twilio/tree/v0.7.0) (2019-01-26)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.6.1...v0.7.0)\n\n**Closed issues:**\n\n- Upgrade to Joken 2.0.0 [\\#113](https://github.com/danielberkompas/ex_twilio/issues/113)\n- `ExTwilio.Member.all queue: queue_sid` fails to parse correct response [\\#111](https://github.com/danielberkompas/ex_twilio/issues/111)\n- Bypass with ExTwilio [\\#109](https://github.com/danielberkompas/ex_twilio/issues/109)\n- Message.create\\(\\) works in v0.6.0 and broken in v0.6.1 [\\#107](https://github.com/danielberkompas/ex_twilio/issues/107)\n- Requesting a release [\\#106](https://github.com/danielberkompas/ex_twilio/issues/106)\n- 202 http status code is handled as error [\\#97](https://github.com/danielberkompas/ex_twilio/issues/97)\n- Finding Subaccount by Friendly Name [\\#93](https://github.com/danielberkompas/ex_twilio/issues/93)\n- Call vs. Messaging [\\#84](https://github.com/danielberkompas/ex_twilio/issues/84)\n\n**Merged pull requests:**\n\n- Upgrade to Joken 2.0 [\\#114](https://github.com/danielberkompas/ex_twilio/pull/114) ([lewisf](https://github.com/lewisf))\n- fixing wrong resource\\_collection\\_name in ExTwilio.Memeber resource [\\#112](https://github.com/danielberkompas/ex_twilio/pull/112) ([mjaric](https://github.com/mjaric))\n- add protocol option for testing [\\#110](https://github.com/danielberkompas/ex_twilio/pull/110) ([BenMorganIO](https://github.com/BenMorganIO))\n- Create Notify resource [\\#105](https://github.com/danielberkompas/ex_twilio/pull/105) ([MortadaAK](https://github.com/MortadaAK))\n- Add docs around sending an SMS message. [\\#104](https://github.com/danielberkompas/ex_twilio/pull/104) ([pdgonzalez872](https://github.com/pdgonzalez872))\n- Parser: Return full error JSON [\\#100](https://github.com/danielberkompas/ex_twilio/pull/100) ([xtian](https://github.com/xtian))\n- Parser to handle 202 http status [\\#98](https://github.com/danielberkompas/ex_twilio/pull/98) ([ins429](https://github.com/ins429))\n\n## [v0.6.1](https://github.com/danielberkompas/ex_twilio/tree/v0.6.1) (2018-10-03)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.6.0...v0.6.1)\n\n**Closed issues:**\n\n- Support for :create on Participant Resource [\\#102](https://github.com/danielberkompas/ex_twilio/issues/102)\n- Utilizing subaccounts / credentials [\\#95](https://github.com/danielberkompas/ex_twilio/issues/95)\n\n**Merged pull requests:**\n\n- Adds create to participant. [\\#103](https://github.com/danielberkompas/ex_twilio/pull/103) ([jip1080](https://github.com/jip1080))\n- add messaging\\_service\\_sid to the message resource [\\#94](https://github.com/danielberkompas/ex_twilio/pull/94) ([swelham](https://github.com/swelham))\n\n## [v0.6.0](https://github.com/danielberkompas/ex_twilio/tree/v0.6.0) (2018-04-16)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.5.1...v0.6.0)\n\n**Closed issues:**\n\n- HTTPoison.Error :nxdomain in lib/ex\\_twilio/api.ex:19 [\\#88](https://github.com/danielberkompas/ex_twilio/issues/88)\n\n**Merged pull requests:**\n\n- Add JWT support [\\#92](https://github.com/danielberkompas/ex_twilio/pull/92) ([danielberkompas](https://github.com/danielberkompas))\n- fix next\\_page\\_url generation & run mix format [\\#91](https://github.com/danielberkompas/ex_twilio/pull/91) ([techgaun](https://github.com/techgaun))\n- feat\\(RequestValidator\\): Adds a module that handles validating request… [\\#90](https://github.com/danielberkompas/ex_twilio/pull/90) ([tomciopp](https://github.com/tomciopp))\n- chore\\(docs\\): Default to reading from system environment variables [\\#89](https://github.com/danielberkompas/ex_twilio/pull/89) ([tomciopp](https://github.com/tomciopp))\n\n## [v0.5.1](https://github.com/danielberkompas/ex_twilio/tree/v0.5.1) (2018-02-24)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.5.0...v0.5.1)\n\n**Closed issues:**\n\n- Retrieving A Programmable Chat User. [\\#85](https://github.com/danielberkompas/ex_twilio/issues/85)\n\n**Merged pull requests:**\n\n- Refactor ExTwilio.ResultStream to simplify streaming code [\\#87](https://github.com/danielberkompas/ex_twilio/pull/87) ([scarfacedeb](https://github.com/scarfacedeb))\n- Remove puts that could not be muted [\\#86](https://github.com/danielberkompas/ex_twilio/pull/86) ([john-griffin](https://github.com/john-griffin))\n- Config does not need system [\\#82](https://github.com/danielberkompas/ex_twilio/pull/82) ([mahcloud](https://github.com/mahcloud))\n\n## [v0.5.0](https://github.com/danielberkompas/ex_twilio/tree/v0.5.0) (2017-09-21)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.4.0...v0.5.0)\n\n**Closed issues:**\n\n- Update to Poison \\>= 3 [\\#72](https://github.com/danielberkompas/ex_twilio/issues/72)\n\n**Merged pull requests:**\n\n- Add all endpoints for the programmable chat api. [\\#81](https://github.com/danielberkompas/ex_twilio/pull/81) ([4141done](https://github.com/4141done))\n- Remove someone's hardcoded workspace sid from the url\\_builder [\\#80](https://github.com/danielberkompas/ex_twilio/pull/80) ([4141done](https://github.com/4141done))\n- Handle query string encoding of list values for the param map. [\\#79](https://github.com/danielberkompas/ex_twilio/pull/79) ([m4ttsch](https://github.com/m4ttsch))\n\n## [v0.4.0](https://github.com/danielberkompas/ex_twilio/tree/v0.4.0) (2017-07-10)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.3.0...v0.4.0)\n\n**Closed issues:**\n\n- Subaccounts support [\\#76](https://github.com/danielberkompas/ex_twilio/issues/76)\n- Add messaging\\_service\\_sid to the Message Resource [\\#75](https://github.com/danielberkompas/ex_twilio/issues/75)\n- Setting MaxPrice on message [\\#70](https://github.com/danielberkompas/ex_twilio/issues/70)\n- Error while creating sms [\\#69](https://github.com/danielberkompas/ex_twilio/issues/69)\n\n**Merged pull requests:**\n\n- 76 - Subaccounts handling [\\#78](https://github.com/danielberkompas/ex_twilio/pull/78) ([andrewshatnyy](https://github.com/andrewshatnyy))\n- Upgrade Joken to 1.4.1 [\\#74](https://github.com/danielberkompas/ex_twilio/pull/74) ([joshuafleck](https://github.com/joshuafleck))\n- Replace 'accound' with 'account' in capability.ex [\\#73](https://github.com/danielberkompas/ex_twilio/pull/73) ([yakryder](https://github.com/yakryder))\n- Adds Update API action to Conference resource. [\\#71](https://github.com/danielberkompas/ex_twilio/pull/71) ([m4ttsch](https://github.com/m4ttsch))\n\n## [v0.3.0](https://github.com/danielberkompas/ex_twilio/tree/v0.3.0) (2017-01-20)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.2.1...v0.3.0)\n\n**Closed issues:**\n\n- Configure accound\\_sid and auth\\_token in run time [\\#65](https://github.com/danielberkompas/ex_twilio/issues/65)\n- protocol String.Chars not implemented for %{\"mms\" =\\> false, \"sms\" =\\> false, \"voice\" =\\> true} [\\#57](https://github.com/danielberkompas/ex_twilio/issues/57)\n- problem with lib [\\#52](https://github.com/danielberkompas/ex_twilio/issues/52)\n- Notifications API url broken [\\#46](https://github.com/danielberkompas/ex_twilio/issues/46)\n\n**Merged pull requests:**\n\n- \\[\\#65\\] Allow runtime config with {:system} tuples [\\#66](https://github.com/danielberkompas/ex_twilio/pull/66) ([danielberkompas](https://github.com/danielberkompas))\n- typo: correct link to the documentation [\\#64](https://github.com/danielberkompas/ex_twilio/pull/64) ([gliush](https://github.com/gliush))\n- Add specifying outgoing client capability params [\\#62](https://github.com/danielberkompas/ex_twilio/pull/62) ([brain-geek](https://github.com/brain-geek))\n- Add caller\\_name field to lookup [\\#61](https://github.com/danielberkompas/ex_twilio/pull/61) ([he9lin](https://github.com/he9lin))\n- Bump elixir version [\\#60](https://github.com/danielberkompas/ex_twilio/pull/60) ([enilsen16](https://github.com/enilsen16))\n- Implement Task Router API [\\#55](https://github.com/danielberkompas/ex_twilio/pull/55) ([enilsen16](https://github.com/enilsen16))\n\n## [v0.2.1](https://github.com/danielberkompas/ex_twilio/tree/v0.2.1) (2016-10-31)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.2.0...v0.2.1)\n\n**Closed issues:**\n\n- where is \"Api.get!\" defined? [\\#48](https://github.com/danielberkompas/ex_twilio/issues/48)\n\n**Merged pull requests:**\n\n- Update joken, mock [\\#58](https://github.com/danielberkompas/ex_twilio/pull/58) ([danielberkompas](https://github.com/danielberkompas))\n- Add instructions for receiving a call in the calling tutorial [\\#54](https://github.com/danielberkompas/ex_twilio/pull/54) ([joshuafleck](https://github.com/joshuafleck))\n- Add lookup rest api [\\#51](https://github.com/danielberkompas/ex_twilio/pull/51) ([enilsen16](https://github.com/enilsen16))\n- Add capability tokens [\\#50](https://github.com/danielberkompas/ex_twilio/pull/50) ([joshuafleck](https://github.com/joshuafleck))\n- Make the recommended config exrm compatible [\\#49](https://github.com/danielberkompas/ex_twilio/pull/49) ([jeffrafter](https://github.com/jeffrafter))\n- Update notifications url \\#46 [\\#47](https://github.com/danielberkompas/ex_twilio/pull/47) ([Devinsuit](https://github.com/Devinsuit))\n\n## [v0.2.0](https://github.com/danielberkompas/ex_twilio/tree/v0.2.0) (2016-07-20)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.1.9...v0.2.0)\n\n**Merged pull requests:**\n\n- Add Credo Linter [\\#45](https://github.com/danielberkompas/ex_twilio/pull/45) ([danielberkompas](https://github.com/danielberkompas))\n- Switch to HTTPoison [\\#44](https://github.com/danielberkompas/ex_twilio/pull/44) ([danielberkompas](https://github.com/danielberkompas))\n\n## [v0.1.9](https://github.com/danielberkompas/ex_twilio/tree/v0.1.9) (2016-07-02)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.1.8...v0.1.9)\n\n**Closed issues:**\n\n- Accessing the Usage logs [\\#39](https://github.com/danielberkompas/ex_twilio/issues/39)\n- Error on sending messages [\\#36](https://github.com/danielberkompas/ex_twilio/issues/36)\n- Add ability to create Capability tokens [\\#28](https://github.com/danielberkompas/ex_twilio/issues/28)\n\n**Merged pull requests:**\n\n- Depend on Hex version of ibrowse [\\#42](https://github.com/danielberkompas/ex_twilio/pull/42) ([danielberkompas](https://github.com/danielberkompas))\n- This makes ex\\_twilio compatible with elixir 1.3 [\\#41](https://github.com/danielberkompas/ex_twilio/pull/41) ([tokafish](https://github.com/tokafish))\n\n## [v0.1.8](https://github.com/danielberkompas/ex_twilio/tree/v0.1.8) (2016-06-06)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.1.7...v0.1.8)\n\n**Closed issues:**\n\n- Lack of domain when running ExTwilio.Call.all\\(\\) [\\#38](https://github.com/danielberkompas/ex_twilio/issues/38)\n- Hex dependency resolution issues [\\#34](https://github.com/danielberkompas/ex_twilio/issues/34)\n- ExTwilio.Message.create throws {:error, \"The requested resource /2010-04-01/Messages.json was not found\", 404} [\\#33](https://github.com/danielberkompas/ex_twilio/issues/33)\n- 2 Factor Authentication [\\#32](https://github.com/danielberkompas/ex_twilio/issues/32)\n- Switch out HTTPotion for Tesla? [\\#10](https://github.com/danielberkompas/ex_twilio/issues/10)\n\n**Merged pull requests:**\n\n- Provide full url to process\\_page when there is more than 50 entries. [\\#40](https://github.com/danielberkompas/ex_twilio/pull/40) ([rlb3](https://github.com/rlb3))\n- Remove unnecessary Utils module and replace its usages with Macro [\\#35](https://github.com/danielberkompas/ex_twilio/pull/35) ([AvaelKross](https://github.com/AvaelKross))\n\n## [v0.1.7](https://github.com/danielberkompas/ex_twilio/tree/v0.1.7) (2016-04-16)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.1.6...v0.1.7)\n\n**Merged pull requests:**\n\n- Fix Parser for Poison 2.0 [\\#31](https://github.com/danielberkompas/ex_twilio/pull/31) ([danielberkompas](https://github.com/danielberkompas))\n\n## [v0.1.6](https://github.com/danielberkompas/ex_twilio/tree/v0.1.6) (2016-04-16)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.1.5...v0.1.6)\n\n## [v0.1.5](https://github.com/danielberkompas/ex_twilio/tree/v0.1.5) (2016-04-16)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.1.4...v0.1.5)\n\n## [v0.1.4](https://github.com/danielberkompas/ex_twilio/tree/v0.1.4) (2016-03-29)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.1.3...v0.1.4)\n\n**Closed issues:**\n\n- Add TaskRouter support [\\#27](https://github.com/danielberkompas/ex_twilio/issues/27)\n- next\\_page and etc implementation?  [\\#23](https://github.com/danielberkompas/ex_twilio/issues/23)\n- How can I use the Message module? [\\#22](https://github.com/danielberkompas/ex_twilio/issues/22)\n\n**Merged pull requests:**\n\n- Upgrade Travis to Elixir 1.2 and OTP 18 [\\#30](https://github.com/danielberkompas/ex_twilio/pull/30) ([danielberkompas](https://github.com/danielberkompas))\n- Allow query strings to contain multiple values for a param [\\#29](https://github.com/danielberkompas/ex_twilio/pull/29) ([brentonannan](https://github.com/brentonannan))\n- add fixes for Elixir 1.2 compiler warnings [\\#26](https://github.com/danielberkompas/ex_twilio/pull/26) ([jeffweiss](https://github.com/jeffweiss))\n- adds required steps for installation [\\#25](https://github.com/danielberkompas/ex_twilio/pull/25) ([AdamBrodzinski](https://github.com/AdamBrodzinski))\n- Remove deleted functions from README [\\#24](https://github.com/danielberkompas/ex_twilio/pull/24) ([danielberkompas](https://github.com/danielberkompas))\n\n## [v0.1.3](https://github.com/danielberkompas/ex_twilio/tree/v0.1.3) (2015-10-08)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.1.2...v0.1.3)\n\n**Closed issues:**\n\n- Drop using `Mix.Utils` in runtime. [\\#19](https://github.com/danielberkompas/ex_twilio/issues/19)\n\n**Merged pull requests:**\n\n- \\[\\#19\\]: Stop using Mix.Utils [\\#21](https://github.com/danielberkompas/ex_twilio/pull/21) ([danielberkompas](https://github.com/danielberkompas))\n- Add missing applications to app template [\\#20](https://github.com/danielberkompas/ex_twilio/pull/20) ([michalmuskala](https://github.com/michalmuskala))\n\n## [v0.1.2](https://github.com/danielberkompas/ex_twilio/tree/v0.1.2) (2015-09-20)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.1.1...v0.1.2)\n\n**Implemented enhancements:**\n\n- Refactor `stream` function, remove list functions [\\#14](https://github.com/danielberkompas/ex_twilio/pull/14) ([danielberkompas](https://github.com/danielberkompas))\n\n**Merged pull requests:**\n\n- Upgrade ExDoc [\\#18](https://github.com/danielberkompas/ex_twilio/pull/18) ([danielberkompas](https://github.com/danielberkompas))\n- Update release script [\\#17](https://github.com/danielberkompas/ex_twilio/pull/17) ([danielberkompas](https://github.com/danielberkompas))\n-  pin Poison dependency to \\>= 1.4 and \\< 2 [\\#16](https://github.com/danielberkompas/ex_twilio/pull/16) ([jeffweiss](https://github.com/jeffweiss))\n- Upgrade ibrowse dependency for R18 support [\\#15](https://github.com/danielberkompas/ex_twilio/pull/15) ([nickcampbell18](https://github.com/nickcampbell18))\n\n## [v0.1.1](https://github.com/danielberkompas/ex_twilio/tree/v0.1.1) (2015-05-22)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.1.0...v0.1.1)\n\n## [v0.1.0](https://github.com/danielberkompas/ex_twilio/tree/v0.1.0) (2015-04-11)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/v0.0.1...v0.1.0)\n\n**Implemented enhancements:**\n\n- Support all Twilio API endpoints [\\#9](https://github.com/danielberkompas/ex_twilio/issues/9)\n- Simplify URL generation logic [\\#4](https://github.com/danielberkompas/ex_twilio/issues/4)\n\n**Closed issues:**\n\n- Create tests for all Resource modules [\\#3](https://github.com/danielberkompas/ex_twilio/issues/3)\n- Add list of supported endpoints to README [\\#2](https://github.com/danielberkompas/ex_twilio/issues/2)\n\n**Merged pull requests:**\n\n- Finish documenting and tests for now [\\#12](https://github.com/danielberkompas/ex_twilio/pull/12) ([danielberkompas](https://github.com/danielberkompas))\n- Support All Twilio REST Endpoints [\\#11](https://github.com/danielberkompas/ex_twilio/pull/11) ([danielberkompas](https://github.com/danielberkompas))\n- Reduce reliance on Enum [\\#8](https://github.com/danielberkompas/ex_twilio/pull/8) ([danielberkompas](https://github.com/danielberkompas))\n- \\[\\#4\\] Rework URL generation [\\#7](https://github.com/danielberkompas/ex_twilio/pull/7) ([danielberkompas](https://github.com/danielberkompas))\n- Run Dialyzer on Travis CI [\\#6](https://github.com/danielberkompas/ex_twilio/pull/6) ([danielberkompas](https://github.com/danielberkompas))\n\n## [v0.0.1](https://github.com/danielberkompas/ex_twilio/tree/v0.0.1) (2015-03-31)\n\n[Full Changelog](https://github.com/danielberkompas/ex_twilio/compare/2f7ff5b721700c53eb86c5b83c63dd655d042f31...v0.0.1)\n\n**Closed issues:**\n\n- Update all inline documentation [\\#1](https://github.com/danielberkompas/ex_twilio/issues/1)\n\n**Merged pull requests:**\n\n- Improve documentation and typespecs for all modules [\\#5](https://github.com/danielberkompas/ex_twilio/pull/5) ([danielberkompas](https://github.com/danielberkompas))\n\n\n\n\\* *This Changelog was automatically generated by [github_changelog_generator](https://github.com/github-changelog-generator/github-changelog-generator)*","ref":"changelog.html"},{"type":"extras","title":"Contributing","doc":"# Contribution Guidelines\n\nI welcome contributions to ExTwilio. Contributors should keep in mind the following rules:\n\n- Pull requests will not be accepted if the Travis build is failing.\n- Code changes should be accompanied with test changes or additions to validate that your changes actually work.\n- Code changes must update inline documentation in all relevant areas. Users rely on this documentation.\n- Any code you submit will be subject to the MIT license.\n- Discussion must be courteous at all times. Offending discussions will be closed and locked.","ref":"contributing.html"},{"type":"extras","title":"License","doc":"The MIT License (MIT)\n\nCopyright (c) 2015 Daniel Berkompas\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"ExTwilio\n========\n\n[![Hex.pm](https://img.shields.io/hexpm/v/ex_twilio.svg)](https://hex.pm/packages/ex_twilio)\n[![Build Status](https://danielberkompas.semaphoreci.com/badges/ex_twilio/branches/master.svg?style=shields)](https://danielberkompas.semaphoreci.com/projects/ex_twilio)\n[![Inline docs](http://inch-ci.org/github/danielberkompas/ex_twilio.svg?branch=master)](http://inch-ci.org/github/danielberkompas/ex_twilio)\n[![Module Version](https://img.shields.io/hexpm/v/ex_twilio.svg)](https://hex.pm/packages/xxx)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/ex_twilio/)\n[![Total Download](https://img.shields.io/hexpm/dt/ex_twilio.svg)](https://hex.pm/packages/xxx)\n[![License](https://img.shields.io/hexpm/l/ex_twilio.svg)](https://github.com/danielberkompas/xxx/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/danielberkompas/ex_twilio.svg)](https://github.com/danielberkompas/xxx/commits/master)\n\nExTwilio is a relatively full-featured API client for the Twilio API.","ref":"readme.html"},{"type":"extras","title":"Installation - Overview","doc":"ExTwilio is currently beta software. You can install it from Hex:\n\n```elixir\ndef deps do\n  [\n    {:ex_twilio, \"~> 0.10.0\"}\n  ]\nend\n```\n\nOr from Github:\n\n```elixir\ndef deps do\n  [\n    {:ex_twilio, github: \"danielberkompas/ex_twilio\"}\n  ]\nend\n```\n\nand run `mix deps.get`.\n\n\nIf using Elixir 1.3 or lower add `:ex_twilio` as a application dependency:\n\n```elixir\ndef application do\n  [\n    applications: [:ex_twilio]\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - Overview","doc":"You will need to set the following configuration variables in your\n`config/config.exs` file:\n\n```elixir\nimport Config\n\nconfig :ex_twilio, account_sid:   {:system, \"TWILIO_ACCOUNT_SID\"},\n                   auth_token:    {:system, \"TWILIO_AUTH_TOKEN\"},\n                   workspace_sid: {:system, \"TWILIO_WORKSPACE_SID\"} # optional\n```\n\nFor security, I recommend that you use environment variables rather than hard\ncoding your account credentials. If you don't already have an environment\nvariable manager, you can create a `.env` file in your project with the\nfollowing content:\n\n```bash\nexport TWILIO_ACCOUNT_SID= \nexport TWILIO_AUTH_TOKEN= \nexport TWILIO_WORKSPACE_SID=  #optional\n```\n\nThen, just be sure to run `source .env` in your shell before compiling your\nproject.\n\n#","ref":"readme.html#configuration"},{"type":"extras","title":"Multiple Environments - Overview","doc":"If you want to use different Twilio credentials for different environments, then\ncreate separate Mix configuration files for each environment. To do this, change\n`config/config.exs` to look like this:\n\n```elixir\n# config/config.exs\n\nimport Config\n\n# shared configuration for all environments here ...\n\nimport_config \"#{Mix.env}.exs\"\n```\n\nThen, create a `config/#{environment_name}.exs` file for each environment. You\ncan then set the `config :ex_twilio` variables differently in each file.","ref":"readme.html#multiple-environments"},{"type":"extras","title":"Usage - Overview","doc":"ExTwilio comes with a module for each supported Twilio API resource. For example,\nthe \"Call\" resource is accessible through the `ExTwilio.Call` module. Depending\non what the underlying API supports, a resource module may have the following\nmethods:\n\n| Method      | Description                                                       |\n|-------------|-------------------------------------------------------------------|\n| **all**     | Eager load all of the resource items on all pages. Use with care! |\n| **stream**  | Create a Stream of all the items. Use like any Stream.            |\n| **find**    | Find a resource given its SID.                                    |\n| **create**  | Create a resource.                                                |\n| **update**  | Update a resource.                                                |\n| **destroy** | Destroy a resource.                                               |\n\nResource modules may contain their own custom methods. If the underlying API\nendpoint does not support an action, the related method will _not_ be available\non that module.\n\n#","ref":"readme.html#usage"},{"type":"extras","title":"Supported Endpoints - Overview","doc":"ExTwilio currently supports the following Twilio endpoints:\n\n- [Account](https://www.twilio.com/docs/api/2010-04-01/rest/account). Including SubAccounts.\n- [Address](https://www.twilio.com/docs/api/2010-04-01/rest/addresses)\n    - [DependentPhoneNumber](https://www.twilio.com/docs/api/2010-04-01/rest/addresses#instance-subresources)\n- [Application](https://www.twilio.com/docs/api/2010-04-01/rest/applications)\n- [AuthorizedConnectApp](https://www.twilio.com/docs/api/2010-04-01/rest/authorized-connect-apps)\n- [AvailablePhoneNumber](https://www.twilio.com/docs/api/2010-04-01/rest/available-phone-numbers)\n- [Call](https://www.twilio.com/docs/api/2010-04-01/rest/call)\n    - [Feedback](https://www.twilio.com/docs/api/2010-04-01/rest/call-feedback)\n- [Conference](https://www.twilio.com/docs/api/2010-04-01/rest/conference)\n    - [Participant](https://www.twilio.com/docs/api/2010-04-01/rest/participant)\n- [ConnectApp](https://www.twilio.com/docs/api/2010-04-01/rest/connect-apps)\n- [IncomingPhoneNumber](https://www.twilio.com/docs/api/2010-04-01/rest/incoming-phone-numbers)\n- [Message](https://www.twilio.com/docs/api/2010-04-01/rest/message)\n    - [Media](https://www.twilio.com/docs/api/2010-04-01/rest/media)\n- [Notification](https://www.twilio.com/docs/api/notifications/rest)\n- [OutgoingCallerId](https://www.twilio.com/docs/api/2010-04-01/rest/outgoing-caller-ids)\n- [Queue](https://www.twilio.com/docs/api/2010-04-01/rest/queue)\n    - [Member](https://www.twilio.com/docs/api/2010-04-01/rest/member)\n- [Recording](https://www.twilio.com/docs/api/2010-04-01/rest/recording)\n- [ShortCode](https://www.twilio.com/docs/api/2010-04-01/rest/short-codes)\n- [Token](https://www.twilio.com/docs/api/2010-04-01/rest/token)\n- [Transcription](https://www.twilio.com/docs/api/2010-04-01/rest/transcription)\n- [SipCredentialList](https://www.twilio.com/docs/api/2010-04-01/rest/credential-list)\n    - [SipCredential](https://www.twilio.com/docs/api/rest/credential-list#subresources)\n- [SipDomain](https://www.twilio.com/docs/api/2010-04-01/rest/domain)\n- [SipIPAccessControlList](https://www.twilio.com/docs/api/2010-04-01/rest/ip-access-control-list)\n    - [SipIpAddress](https://www.twilio.com/docs/api/rest/ip-access-control-list#subresources)\n\nTwilio's Lookup Rest API:\n\n- [Lookup](https://www.twilio.com/docs/api/lookups)\n\nTwilio's TaskRouter API:\n\n- [Overview](https://www.twilio.com/docs/api/taskrouter/rest-api)\n- [Activites](https://www.twilio.com/docs/api/taskrouter/activities)\n- [Events](https://www.twilio.com/docs/api/taskrouter/events)\n- [Task Channels](https://www.twilio.com/docs/api/taskrouter/rest-api-task-channel)\n- [Tasks](https://www.twilio.com/docs/api/taskrouter/tasks)\n    - [Reservations](https://www.twilio.com/docs/api/taskrouter/reservations)\n- [TaskQueues](https://www.twilio.com/docs/api/taskrouter/taskqueues)\n    - [Statistics](https://www.twilio.com/docs/api/taskrouter/taskqueue-statistics)\n- [Workers](https://www.twilio.com/docs/api/taskrouter/workers)\n    - [Channels](https://www.twilio.com/docs/api/taskrouter/rest-api-workerchannel)\n    - [Statistics](https://www.twilio.com/docs/api/taskrouter/worker-statistics)\n- [Workflows](https://www.twilio.com/docs/api/taskrouter/workflows)\n    - [Statistics](https://www.twilio.com/docs/api/taskrouter/workflow-statistics)\n- [Workspaces](https://www.twilio.com/docs/api/taskrouter/workspaces)\n    - [Statistics](https://www.twilio.com/docs/api/taskrouter/workspace-statistics)\n\nTwilio's ProgrammableChat API:\n\n- [Overview](https://www.twilio.com/docs/api/chat/rest)\n- [Services](https://www.twilio.com/docs/api/chat/rest/services)\n  - [Channels](https://www.twilio.com/docs/api/chat/rest/channels)\n    - [Members](https://www.twilio.com/docs/api/chat/rest/members)\n  - [Users](https://www.twilio.com/docs/api/chat/rest/users)\n    - [UserChannels](https://www.twilio.com/docs/api/chat/rest/user-channels)\n  - [Roles](https://www.twilio.com/docs/api/chat/rest/user-channels)\n- [Credentials](https://www.twilio.com/docs/api/chat/rest/credentials)\n\nTwilio Capability Tokens:\n- [Worker](https://www.twilio.com/docs/api/taskrouter/worker-js)\n- [Calling](https://www.twilio.com/docs/api/client/capability-tokens) (Deprecated, use Access Token instead)\n\nTwilio Access Token Grants:\n- [Chat](https://www.twilio.com/docs/chat/identity)\n- [Voice](https://www.twilio.com/docs/iam/access-tokens)\n- [Video](https://www.twilio.com/docs/video/tutorials/user-identity-access-tokens#about-access-tokens)\n\n#","ref":"readme.html#supported-endpoints"},{"type":"extras","title":"Example - Overview","doc":"```elixir\n# Get all the calls in the Call endpoint. Be warned, this will block\n# until all the pages of calls have been fetched.\ncalls = ExTwilio.Call.all\n\n# Create a stream of all the calls\nstream = ExTwilio.Call.stream\n\n# Lazily filter calls by duration, then map to get only their SIDs\nstream\n|> Stream.filter(fn(call) -> call.duration > 120 end)\n|> Stream.map(fn(call) -> call.sid end)\n|> Enum.into([]) # Only here does any work happen.\n# => [\"CAc14d7...\", \"CA649ea861...\"]\n\n# Find a call\n{:ok, call} = ExTwilio.Call.find(\"CA13a9c7f80c6f3761fabae43242b5b6c6\")\ninspect(call)\n# %ExTwilio.Call{\n#   account_sid: \"ACxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\",\n#   answered_by: nil, caller_name: \"\",\n#   date_created: \"Sat, 14 Mar 2015 14:27:38 +0000\",\n#   date_updated: \"Sat, 14 Mar 2015 14:28:35 +0000\",\n#   direction: \"outbound-api\",\n#   duration: \"52\",\n#   end_time: \"Sat, 14 Mar 2015 14:28:35 +0000\",\n#   forwarded_from: nil,\n#   from: \"+1xxxxxxxxxx\",\n#   parent_call_sid: nil,\n#   phone_number_sid: \"\",\n#   price: \"-0.01500\",\n#   price_unit: \"USD\",\n#   sid: \"CA13a9c7f80c6f3761fabae43242b5b6c6\",\n#   start_time: \"Sat, 14 Mar 2015 14:27:43 +0000\",\n#   status: \"completed\",\n#   to: \"+1xxxxxxxxxx\",\n#   uri: \"/2010-04-01/Accounts/ACxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx/Calls/CAxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx.json\"\n# }\n\n# Update a call\ncall = ExTwilio.Call.update(call, status: \"canceled\")\n\n# Get a call's recordings. This pattern is repeated wherever you are\n# getting a nested resource.\nrecordings = ExTwilio.Recording.all(call: call.sid)\n\n# Destroy a call\nExTwilio.Call.destroy(call)\n```\n\nFor more in-depth documentation, see the generated docs for each module.\n\n#","ref":"readme.html#example"},{"type":"extras","title":"Making and Receiving Calls - Overview","doc":"See the [CALLING_TUTORIAL.md](CALLING_TUTORIAL.md) file for instructions on\nmaking and receiving calls from the browser with ExTwilio.\n\n\n#","ref":"readme.html#making-and-receiving-calls"},{"type":"extras","title":"Sending SMS messages - Overview","doc":"Please look at `ExTwilio.Message`","ref":"readme.html#sending-sms-messages"},{"type":"extras","title":"Contributing - Overview","doc":"See the [CONTRIBUTING.md](CONTRIBUTING.md) file for contribution guidelines.","ref":"readme.html#contributing"},{"type":"extras","title":"Copyright and License - Overview","doc":"Copyright (c) 2015 Daniel Berkompas\n\nExTwilio is licensed under the MIT license. For more details, see the `LICENSE`\nfile at the root of the repository. It depends on Elixir, which is under the\nApache 2 license.\n\nTwilio™ is trademark of Twilio, Inc.","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"Calling Tutorial","doc":"Making and Receiving Calls from the Browser\n-------------------------------------------\n\nAs of 2016-08-29, the Twilio [quickstart docs](https://www.twilio.com/docs/quickstart)\ndo not contain examples for Elixir. Some examples for Elixir can be found in this tutorial.\n\nTo begin, create an empty Phoenix application called `Demo` and install and configure\nExTwilio per the instructions on the [README](README.md#configuration).","ref":"calling_tutorial.html"},{"type":"extras","title":"Making a Call - Calling Tutorial","doc":"Create a controller with a `show` action, and generate a Twilio capability\ntoken with the specified application sid (it plays a welcome message)\n\n```elixir\ndefmodule Demo.TwilioController do\n  use Demo.Web, :controller\n\n  def show(conn, _params) do\n    token =\n      ExTwilio.Capability.new\n      |> ExTwilio.Capability.allow_client_outgoing(\"APabe7650f654fc34655fc81ae71caa3ff\")\n      |> ExTwilio.Capability.token\n\n    render(conn, \"show.html\", token: token)\n  end\nend\n```\n\nCreate a view template for the `show` action\n\n```html\n  \n \n \n \n\n/* Create the Client with a Capability Token */\nTwilio.Device.setup(\"<%= @token %>\", {debug: true});\n\n/* Let us know when the client is ready. */\nTwilio.Device.ready(function (device) {\n    $(\"#log\").text(\"Ready\");\n});\n\n/* Report any errors on the screen */\nTwilio.Device.error(function (error) {\n    $(\"#log\").text(\"Error: \" + error.message);\n});\n\nTwilio.Device.connect(function (conn) {\n    $(\"#log\").text(\"Successfully established call\");\n});\n\n/* Log a message when a call disconnects. */\nTwilio.Device.disconnect(function (conn) {\n    $(\"#log\").text(\"Call ended\");\n});\n\n/* Connect to Twilio when we call this function. */\nfunction call() {\n    Twilio.Device.connect();\n}\n\n/* A function to end a connection to Twilio. */\nfunction hangup() {\n    Twilio.Device.disconnectAll();\n}\n \n\n \n  Call\n \n\n<!-- use an onclick action to hang up the call when the user presses\nthe button -->\n \n  Hangup\n \n  \n```\n\nStart Phoenix and open the page in the browser. Click the `Call` button and you should\nhear the Twilio welcome message.","ref":"calling_tutorial.html#making-a-call"},{"type":"extras","title":"Receiving a Call - Calling Tutorial","doc":"Create a controller with a `show` action and generate a Twilio capability\ntoken with the name _jenny_, which will allow Jenny to receive incoming calls\n\n```elixir\ndefmodule Demo.TwilioController do\n  use Demo.Web, :controller\n\n  def show(conn, _params) do\n    token =\n      ExTwilio.Capability.new\n      |> ExTwilio.Capability.allow_client_incoming(\"jenny\")\n      |> ExTwilio.Capability.token\n\n    render(conn, \"show.html\", token: token)\n  end\nend\n```\n\nCreate a view template for the `show` action\n\n```html\n  \n \n \n \n\n/* Create the Client with a Capability Token */\nTwilio.Device.setup(\"<%= @token %>\", {debug: true});\n\n/* Let us know when the client is ready. */\nTwilio.Device.ready(function (device) {\n    $(\"#log\").text(\"Ready\");\n});\n\n/* Report any errors on the screen */\nTwilio.Device.error(function (error) {\n    $(\"#log\").text(\"Error: \" + error.message);\n});\n\nTwilio.Device.connect(function (conn) {\n    $(\"#log\").text(\"Successfully established call\");\n});\n\n/* Log a message when a call disconnects. */\nTwilio.Device.disconnect(function (conn) {\n    $(\"#log\").text(\"Call ended\");\n});\n\n/* Listen for incoming connections */\nTwilio.Device.incoming(function (conn) {\n  $(\"#log\").text(\"Incoming connection from \" + conn.parameters.From);\n  // accept the incoming connection and start two-way audio\n  conn.accept();\n});\n\n/* A function to end a connection to Twilio. */\nfunction hangup() {\n    Twilio.Device.disconnectAll();\n}\n \n\n<!-- use an onclick action to hang up the call when the user presses\nthe button -->\n \n  Hangup\n \n  \n```\n\nNext, we need to create a controller action that will render some TwiML instructing Twilio to connect any incoming calls to the client named _jenny_. There is a library called [ExTwiml](https://github.com/danielberkompas/ex_twiml) that provides a nice DSL for generating TwiML with Elixir. Add it as a dependency with `{:ex_twiml, \"~> 2.1.0\"}`.\n\nCreate the following controller action and module for rendering the TwiML\n\n```elixir\ndefmodule Demo.TwilioController do\n  use Demo.Web, :controller\n\n  def show(conn, _params) do\n    token =\n      ExTwilio.Capability.new\n      |> ExTwilio.Capability.allow_client_incoming(\"jenny\")\n      |> ExTwilio.Capability.token\n\n    render(conn, \"show.html\", token: token)\n  end\n\n  # Note: By default, Twilio will POST to this endpoint\n  def voice(conn, _params) do\n    resp = Demo.Twiml.dial_jenny\n    conn\n    |> put_resp_content_type(\"text/xml\")\n    |> text(resp)\n  end\nend\n\ndefmodule Demo.Twiml do\n  import ExTwiml\n\n  def dial_jenny do\n    twiml do\n      # This should be your Twilio Number or verified Caller ID\n      dial callerid: \"+1XXXXXXX\" do\n        client \"jenny\"\n      end\n    end\n  end\nend\n```\n\nOnce you've started your web server, you can expose your endpoint to the world with a tool like [Ngrok](https://ngrok.com/), pointing it to your development server on port 4000\n\n    $ ngrok http 4000\n\nCreate a [TwiML application](https://www.twilio.com/console/voice/dev-tools/twiml-apps) on Twilio, which will tell Twilio where to get instructions for routing incoming calls. Set the URL to point to your `voice` endpoint exposed by Ngrok, e.g.\n\n`http://xxxxxxxx.ngrok.io/voice` _Note: this URL will change every time you restart Ngrok_\n\nIn order to test making an inbound call to your client, you can use the `Call` button visible on the Twilio console page for your TwiML application. Open the page corresponding to the `show` action in your browser. Then, on a different computer, click the `Call` button on the Twilio console - you should be able to carry on a conversation through your browsers.","ref":"calling_tutorial.html#receiving-a-call"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}